/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv;

import java.math.BigInteger;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.memory.Label;
import ru.ispras.microtesk.model.memory.Memory;

/**
 * The {@code PE} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PE extends ProcessingElement {
  public final Memory XREG;
  public final Memory FPR;
  public final Memory PC;
  public final Memory CSR;
  public final Memory MEM;
  public final Memory LOAD_RESERVATION;
  public final Memory FFLAGS_CSR;
  public final Memory FFLAGS_EXCEP;
  public final Memory FRM_CSR;
  public final Memory FRM_FRM;
  public final Memory FCSR_CSR;
  public final Memory FCSR_EXCEP;
  public final Memory FCSR_NX;
  public final Memory FCSR_UF;
  public final Memory FCSR_OF;
  public final Memory FCSR_DZ;
  public final Memory FCSR_NV;
  public final Memory FCSR_FRM;
  public final Memory VL_CSR;
  public final Memory VTYPE_CSR;
  public final Memory VTYPE_VILL;
  public final Memory VTYPE_VEDIV;
  public final Memory VTYPE_VSEW;
  public final Memory VTYPE_VLMUL;
  public final Memory STVEC_CSR;
  public final Memory SEPC_CSR;
  public final Memory SCAUSE_CSR;
  public final Memory STVAL_CSR;
  public final Memory SATP_CSR;
  public final Memory SATP_MODE;
  public final Memory SATP_ASID;
  public final Memory SATP_PPN;
  public final Memory MSTATUS_CSR;
  public final Memory MSTATUS_SD;
  public final Memory MSTATUS_SXL;
  public final Memory MSTATUS_UXL;
  public final Memory MSTATUS_TSR;
  public final Memory MSTATUS_TW;
  public final Memory MSTATUS_TVM;
  public final Memory MSTATUS_MXR;
  public final Memory MSTATUS_SUM;
  public final Memory MSTATUS_XS;
  public final Memory MSTATUS_FS;
  public final Memory MSTATUS_MPP;
  public final Memory MSTATUS_SPP;
  public final Memory MSTATUS_MPIE;
  public final Memory MSTATUS_SPIE;
  public final Memory MSTATUS_UPIE;
  public final Memory MSTATUS_MIE;
  public final Memory MSTATUS_SIE;
  public final Memory MSTATUS_UIE;
  public final Memory MISA_CSR;
  public final Memory MISA_U;
  public final Memory MISA_S;
  public final Memory MEDELEG_CSR;
  public final Memory MTVEC_CSR;
  public final Memory MEPC_CSR;
  public final Memory MCAUSE_CSR;
  public final Memory MTVAL_CSR;
  public final Memory DCSR_CSR;
  public final Memory DCSR_PRV;
  public final Memory DCSR_CAUSE;
  public final Memory DCSR_EBREAKU;
  public final Memory DCSR_EBREAKS;
  public final Memory DCSR_EBREAKM;
  public final Memory PRV;
  public final Memory DPC_CSR;
  public final Memory t_cause;
  public final Memory t_get_tval;
  public final Memory privilege_mode;
  public final Memory VREG;

  private PE() {
    super();
    this.XREG = Memory.def(Memory.Kind.REG, "XREG", TypeDefs.XWORD, 32);
    this.FPR = Memory.def(Memory.Kind.REG, "FPR", Type.CARD(64), 32);
    this.PC = Memory.def(Memory.Kind.REG, "PC", TypeDefs.XWORD, 1);
    this.CSR = Memory.def(Memory.Kind.REG, "CSR", TypeDefs.CSR_TYPE, 0x1000);
    this.MEM = Memory.def(Memory.Kind.MEM, "MEM", TypeDefs.DWORD, 0x20000000000000L);
    this.LOAD_RESERVATION = Memory.def(Memory.Kind.REG, "LOAD_RESERVATION", TypeDefs.XWORD, 1);
    this.FFLAGS_CSR = Memory.def(Memory.Kind.REG, "FFLAGS_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(1));
    this.FFLAGS_EXCEP = Memory.def(Memory.Kind.REG, "FFLAGS_EXCEP", Type.CARD(5), 1, FFLAGS_CSR.access().bitField(4, 0));
    this.FRM_CSR = Memory.def(Memory.Kind.REG, "FRM_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(2));
    this.FRM_FRM = Memory.def(Memory.Kind.REG, "FRM_FRM", Type.CARD(3), 1, FRM_CSR.access().bitField(2, 0));
    this.FCSR_CSR = Memory.def(Memory.Kind.REG, "FCSR_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(3));
    this.FCSR_EXCEP = Memory.def(Memory.Kind.REG, "FCSR_EXCEP", Type.CARD(5), 1, FCSR_CSR.access().bitField(4, 0));
    this.FCSR_NX = Memory.def(Memory.Kind.REG, "FCSR_NX", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(0, 0));
    this.FCSR_UF = Memory.def(Memory.Kind.REG, "FCSR_UF", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(1, 1));
    this.FCSR_OF = Memory.def(Memory.Kind.REG, "FCSR_OF", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(2, 2));
    this.FCSR_DZ = Memory.def(Memory.Kind.REG, "FCSR_DZ", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(3, 3));
    this.FCSR_NV = Memory.def(Memory.Kind.REG, "FCSR_NV", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(4, 4));
    this.FCSR_FRM = Memory.def(Memory.Kind.REG, "FCSR_FRM", Type.CARD(3), 1, FCSR_CSR.access().bitField(7, 5));
    this.VL_CSR = Memory.def(Memory.Kind.REG, "VL_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(3104));
    this.VTYPE_CSR = Memory.def(Memory.Kind.REG, "VTYPE_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(3105));
    this.VTYPE_VILL = Memory.def(Memory.Kind.REG, "VTYPE_VILL", TypeDefs.BIT, 1, VTYPE_CSR.access().bitField(63, 63));
    this.VTYPE_VEDIV = Memory.def(Memory.Kind.REG, "VTYPE_VEDIV", Type.CARD(2), 1, VTYPE_CSR.access().bitField(6, 5));
    this.VTYPE_VSEW = Memory.def(Memory.Kind.REG, "VTYPE_VSEW", Type.CARD(3), 1, VTYPE_CSR.access().bitField(4, 2));
    this.VTYPE_VLMUL = Memory.def(Memory.Kind.REG, "VTYPE_VLMUL", Type.CARD(2), 1, VTYPE_CSR.access().bitField(1, 0));
    this.STVEC_CSR = Memory.def(Memory.Kind.REG, "STVEC_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(261));
    this.SEPC_CSR = Memory.def(Memory.Kind.REG, "SEPC_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(321));
    this.SCAUSE_CSR = Memory.def(Memory.Kind.REG, "SCAUSE_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(322));
    this.STVAL_CSR = Memory.def(Memory.Kind.REG, "STVAL_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(323));
    this.SATP_CSR = Memory.def(Memory.Kind.REG, "SATP_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(384));
    this.SATP_MODE = Memory.def(Memory.Kind.REG, "SATP_MODE", Type.CARD(4), 1, SATP_CSR.access().bitField(63, 60));
    this.SATP_ASID = Memory.def(Memory.Kind.REG, "SATP_ASID", Type.CARD(16), 1, SATP_CSR.access().bitField(59, 44));
    this.SATP_PPN = Memory.def(Memory.Kind.REG, "SATP_PPN", Type.CARD(44), 1, SATP_CSR.access().bitField(43, 0));
    this.MSTATUS_CSR = Memory.def(Memory.Kind.REG, "MSTATUS_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(768));
    this.MSTATUS_SD = Memory.def(Memory.Kind.REG, "MSTATUS_SD", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(63, 63));
    this.MSTATUS_SXL = Memory.def(Memory.Kind.REG, "MSTATUS_SXL", Type.CARD(2), 1, MSTATUS_CSR.access().bitField(35, 34));
    this.MSTATUS_UXL = Memory.def(Memory.Kind.REG, "MSTATUS_UXL", Type.CARD(2), 1, MSTATUS_CSR.access().bitField(33, 32));
    this.MSTATUS_TSR = Memory.def(Memory.Kind.REG, "MSTATUS_TSR", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(22, 22));
    this.MSTATUS_TW = Memory.def(Memory.Kind.REG, "MSTATUS_TW", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(21, 21));
    this.MSTATUS_TVM = Memory.def(Memory.Kind.REG, "MSTATUS_TVM", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(20, 20));
    this.MSTATUS_MXR = Memory.def(Memory.Kind.REG, "MSTATUS_MXR", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(19, 19));
    this.MSTATUS_SUM = Memory.def(Memory.Kind.REG, "MSTATUS_SUM", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(18, 18));
    this.MSTATUS_XS = Memory.def(Memory.Kind.REG, "MSTATUS_XS", Type.CARD(2), 1, MSTATUS_CSR.access().bitField(16, 15));
    this.MSTATUS_FS = Memory.def(Memory.Kind.REG, "MSTATUS_FS", Type.CARD(2), 1, MSTATUS_CSR.access().bitField(14, 13));
    this.MSTATUS_MPP = Memory.def(Memory.Kind.REG, "MSTATUS_MPP", Type.CARD(2), 1, MSTATUS_CSR.access().bitField(12, 11));
    this.MSTATUS_SPP = Memory.def(Memory.Kind.REG, "MSTATUS_SPP", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(8, 8));
    this.MSTATUS_MPIE = Memory.def(Memory.Kind.REG, "MSTATUS_MPIE", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(7, 7));
    this.MSTATUS_SPIE = Memory.def(Memory.Kind.REG, "MSTATUS_SPIE", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(5, 5));
    this.MSTATUS_UPIE = Memory.def(Memory.Kind.REG, "MSTATUS_UPIE", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(4, 4));
    this.MSTATUS_MIE = Memory.def(Memory.Kind.REG, "MSTATUS_MIE", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(3, 3));
    this.MSTATUS_SIE = Memory.def(Memory.Kind.REG, "MSTATUS_SIE", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(1, 1));
    this.MSTATUS_UIE = Memory.def(Memory.Kind.REG, "MSTATUS_UIE", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(0, 0));
    this.MISA_CSR = Memory.def(Memory.Kind.REG, "MISA_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(769));
    this.MISA_U = Memory.def(Memory.Kind.REG, "MISA_U", TypeDefs.BIT, 1, MISA_CSR.access().bitField(20, 20));
    this.MISA_S = Memory.def(Memory.Kind.REG, "MISA_S", TypeDefs.BIT, 1, MISA_CSR.access().bitField(18, 18));
    this.MEDELEG_CSR = Memory.def(Memory.Kind.REG, "MEDELEG_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(770));
    this.MTVEC_CSR = Memory.def(Memory.Kind.REG, "MTVEC_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(773));
    this.MEPC_CSR = Memory.def(Memory.Kind.REG, "MEPC_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(833));
    this.MCAUSE_CSR = Memory.def(Memory.Kind.REG, "MCAUSE_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(834));
    this.MTVAL_CSR = Memory.def(Memory.Kind.REG, "MTVAL_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(835));
    this.DCSR_CSR = Memory.def(Memory.Kind.REG, "DCSR_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(1968));
    this.DCSR_PRV = Memory.def(Memory.Kind.REG, "DCSR_PRV", Type.CARD(2), 1, DCSR_CSR.access().bitField(1, 0));
    this.DCSR_CAUSE = Memory.def(Memory.Kind.REG, "DCSR_CAUSE", Type.CARD(3), 1, DCSR_CSR.access().bitField(8, 6));
    this.DCSR_EBREAKU = Memory.def(Memory.Kind.REG, "DCSR_EBREAKU", TypeDefs.BIT, 1, DCSR_CSR.access().bitField(12, 12));
    this.DCSR_EBREAKS = Memory.def(Memory.Kind.REG, "DCSR_EBREAKS", TypeDefs.BIT, 1, DCSR_CSR.access().bitField(13, 13));
    this.DCSR_EBREAKM = Memory.def(Memory.Kind.REG, "DCSR_EBREAKM", TypeDefs.BIT, 1, DCSR_CSR.access().bitField(15, 15));
    this.PRV = Memory.def(Memory.Kind.REG, "PRV", Type.CARD(2), 1, DCSR_PRV.access());
    this.DPC_CSR = Memory.def(Memory.Kind.REG, "DPC_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(1969));
    this.t_cause = Memory.def(Memory.Kind.REG, "t_cause", TypeDefs.CSR_TYPE, 1);
    this.t_get_tval = Memory.def(Memory.Kind.REG, "t_get_tval", TypeDefs.CSR_TYPE, 1);
    this.privilege_mode = Memory.def(Memory.Kind.REG, "privilege_mode", Type.CARD(2), 1);
    this.VREG = Memory.def(Memory.Kind.REG, "VREG", TypeDefs.WORD, 32);

    registerAll();
  }

  private PE(final PE other, final boolean shared) {
    super(other);
    this.XREG = other.XREG.copy();
    this.FPR = other.FPR.copy();
    this.PC = other.PC.copy();
    this.CSR = other.CSR.copy();
    this.MEM = shared ? other.MEM : other.MEM.copy();
    this.LOAD_RESERVATION = other.LOAD_RESERVATION.copy();
    this.FFLAGS_CSR = Memory.def(Memory.Kind.REG, "FFLAGS_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(1));
    this.FFLAGS_EXCEP = Memory.def(Memory.Kind.REG, "FFLAGS_EXCEP", Type.CARD(5), 1, FFLAGS_CSR.access().bitField(4, 0));
    this.FRM_CSR = Memory.def(Memory.Kind.REG, "FRM_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(2));
    this.FRM_FRM = Memory.def(Memory.Kind.REG, "FRM_FRM", Type.CARD(3), 1, FRM_CSR.access().bitField(2, 0));
    this.FCSR_CSR = Memory.def(Memory.Kind.REG, "FCSR_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(3));
    this.FCSR_EXCEP = Memory.def(Memory.Kind.REG, "FCSR_EXCEP", Type.CARD(5), 1, FCSR_CSR.access().bitField(4, 0));
    this.FCSR_NX = Memory.def(Memory.Kind.REG, "FCSR_NX", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(0, 0));
    this.FCSR_UF = Memory.def(Memory.Kind.REG, "FCSR_UF", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(1, 1));
    this.FCSR_OF = Memory.def(Memory.Kind.REG, "FCSR_OF", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(2, 2));
    this.FCSR_DZ = Memory.def(Memory.Kind.REG, "FCSR_DZ", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(3, 3));
    this.FCSR_NV = Memory.def(Memory.Kind.REG, "FCSR_NV", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(4, 4));
    this.FCSR_FRM = Memory.def(Memory.Kind.REG, "FCSR_FRM", Type.CARD(3), 1, FCSR_CSR.access().bitField(7, 5));
    this.VL_CSR = Memory.def(Memory.Kind.REG, "VL_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(3104));
    this.VTYPE_CSR = Memory.def(Memory.Kind.REG, "VTYPE_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(3105));
    this.VTYPE_VILL = Memory.def(Memory.Kind.REG, "VTYPE_VILL", TypeDefs.BIT, 1, VTYPE_CSR.access().bitField(63, 63));
    this.VTYPE_VEDIV = Memory.def(Memory.Kind.REG, "VTYPE_VEDIV", Type.CARD(2), 1, VTYPE_CSR.access().bitField(6, 5));
    this.VTYPE_VSEW = Memory.def(Memory.Kind.REG, "VTYPE_VSEW", Type.CARD(3), 1, VTYPE_CSR.access().bitField(4, 2));
    this.VTYPE_VLMUL = Memory.def(Memory.Kind.REG, "VTYPE_VLMUL", Type.CARD(2), 1, VTYPE_CSR.access().bitField(1, 0));
    this.STVEC_CSR = Memory.def(Memory.Kind.REG, "STVEC_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(261));
    this.SEPC_CSR = Memory.def(Memory.Kind.REG, "SEPC_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(321));
    this.SCAUSE_CSR = Memory.def(Memory.Kind.REG, "SCAUSE_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(322));
    this.STVAL_CSR = Memory.def(Memory.Kind.REG, "STVAL_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(323));
    this.SATP_CSR = Memory.def(Memory.Kind.REG, "SATP_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(384));
    this.SATP_MODE = Memory.def(Memory.Kind.REG, "SATP_MODE", Type.CARD(4), 1, SATP_CSR.access().bitField(63, 60));
    this.SATP_ASID = Memory.def(Memory.Kind.REG, "SATP_ASID", Type.CARD(16), 1, SATP_CSR.access().bitField(59, 44));
    this.SATP_PPN = Memory.def(Memory.Kind.REG, "SATP_PPN", Type.CARD(44), 1, SATP_CSR.access().bitField(43, 0));
    this.MSTATUS_CSR = Memory.def(Memory.Kind.REG, "MSTATUS_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(768));
    this.MSTATUS_SD = Memory.def(Memory.Kind.REG, "MSTATUS_SD", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(63, 63));
    this.MSTATUS_SXL = Memory.def(Memory.Kind.REG, "MSTATUS_SXL", Type.CARD(2), 1, MSTATUS_CSR.access().bitField(35, 34));
    this.MSTATUS_UXL = Memory.def(Memory.Kind.REG, "MSTATUS_UXL", Type.CARD(2), 1, MSTATUS_CSR.access().bitField(33, 32));
    this.MSTATUS_TSR = Memory.def(Memory.Kind.REG, "MSTATUS_TSR", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(22, 22));
    this.MSTATUS_TW = Memory.def(Memory.Kind.REG, "MSTATUS_TW", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(21, 21));
    this.MSTATUS_TVM = Memory.def(Memory.Kind.REG, "MSTATUS_TVM", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(20, 20));
    this.MSTATUS_MXR = Memory.def(Memory.Kind.REG, "MSTATUS_MXR", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(19, 19));
    this.MSTATUS_SUM = Memory.def(Memory.Kind.REG, "MSTATUS_SUM", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(18, 18));
    this.MSTATUS_XS = Memory.def(Memory.Kind.REG, "MSTATUS_XS", Type.CARD(2), 1, MSTATUS_CSR.access().bitField(16, 15));
    this.MSTATUS_FS = Memory.def(Memory.Kind.REG, "MSTATUS_FS", Type.CARD(2), 1, MSTATUS_CSR.access().bitField(14, 13));
    this.MSTATUS_MPP = Memory.def(Memory.Kind.REG, "MSTATUS_MPP", Type.CARD(2), 1, MSTATUS_CSR.access().bitField(12, 11));
    this.MSTATUS_SPP = Memory.def(Memory.Kind.REG, "MSTATUS_SPP", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(8, 8));
    this.MSTATUS_MPIE = Memory.def(Memory.Kind.REG, "MSTATUS_MPIE", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(7, 7));
    this.MSTATUS_SPIE = Memory.def(Memory.Kind.REG, "MSTATUS_SPIE", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(5, 5));
    this.MSTATUS_UPIE = Memory.def(Memory.Kind.REG, "MSTATUS_UPIE", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(4, 4));
    this.MSTATUS_MIE = Memory.def(Memory.Kind.REG, "MSTATUS_MIE", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(3, 3));
    this.MSTATUS_SIE = Memory.def(Memory.Kind.REG, "MSTATUS_SIE", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(1, 1));
    this.MSTATUS_UIE = Memory.def(Memory.Kind.REG, "MSTATUS_UIE", TypeDefs.BIT, 1, MSTATUS_CSR.access().bitField(0, 0));
    this.MISA_CSR = Memory.def(Memory.Kind.REG, "MISA_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(769));
    this.MISA_U = Memory.def(Memory.Kind.REG, "MISA_U", TypeDefs.BIT, 1, MISA_CSR.access().bitField(20, 20));
    this.MISA_S = Memory.def(Memory.Kind.REG, "MISA_S", TypeDefs.BIT, 1, MISA_CSR.access().bitField(18, 18));
    this.MEDELEG_CSR = Memory.def(Memory.Kind.REG, "MEDELEG_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(770));
    this.MTVEC_CSR = Memory.def(Memory.Kind.REG, "MTVEC_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(773));
    this.MEPC_CSR = Memory.def(Memory.Kind.REG, "MEPC_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(833));
    this.MCAUSE_CSR = Memory.def(Memory.Kind.REG, "MCAUSE_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(834));
    this.MTVAL_CSR = Memory.def(Memory.Kind.REG, "MTVAL_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(835));
    this.DCSR_CSR = Memory.def(Memory.Kind.REG, "DCSR_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(1968));
    this.DCSR_PRV = Memory.def(Memory.Kind.REG, "DCSR_PRV", Type.CARD(2), 1, DCSR_CSR.access().bitField(1, 0));
    this.DCSR_CAUSE = Memory.def(Memory.Kind.REG, "DCSR_CAUSE", Type.CARD(3), 1, DCSR_CSR.access().bitField(8, 6));
    this.DCSR_EBREAKU = Memory.def(Memory.Kind.REG, "DCSR_EBREAKU", TypeDefs.BIT, 1, DCSR_CSR.access().bitField(12, 12));
    this.DCSR_EBREAKS = Memory.def(Memory.Kind.REG, "DCSR_EBREAKS", TypeDefs.BIT, 1, DCSR_CSR.access().bitField(13, 13));
    this.DCSR_EBREAKM = Memory.def(Memory.Kind.REG, "DCSR_EBREAKM", TypeDefs.BIT, 1, DCSR_CSR.access().bitField(15, 15));
    this.PRV = Memory.def(Memory.Kind.REG, "PRV", Type.CARD(2), 1, DCSR_PRV.access());
    this.DPC_CSR = Memory.def(Memory.Kind.REG, "DPC_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(1969));
    this.t_cause = other.t_cause.copy();
    this.t_get_tval = other.t_get_tval.copy();
    this.privilege_mode = other.privilege_mode.copy();
    this.VREG = other.VREG.copy();

    registerAll();
  }

  private void registerAll() {
    addStorage(XREG);
    addStorage(FPR);
    addStorage(PC);
    addStorage(CSR);
    addStorage(MEM);
    addStorage(LOAD_RESERVATION);
    addStorage(FFLAGS_CSR);
    addStorage(FFLAGS_EXCEP);
    addStorage(FRM_CSR);
    addStorage(FRM_FRM);
    addStorage(FCSR_CSR);
    addStorage(FCSR_EXCEP);
    addStorage(FCSR_NX);
    addStorage(FCSR_UF);
    addStorage(FCSR_OF);
    addStorage(FCSR_DZ);
    addStorage(FCSR_NV);
    addStorage(FCSR_FRM);
    addStorage(VL_CSR);
    addStorage(VTYPE_CSR);
    addStorage(VTYPE_VILL);
    addStorage(VTYPE_VEDIV);
    addStorage(VTYPE_VSEW);
    addStorage(VTYPE_VLMUL);
    addStorage(STVEC_CSR);
    addStorage(SEPC_CSR);
    addStorage(SCAUSE_CSR);
    addStorage(STVAL_CSR);
    addStorage(SATP_CSR);
    addStorage(SATP_MODE);
    addStorage(SATP_ASID);
    addStorage(SATP_PPN);
    addStorage(MSTATUS_CSR);
    addStorage(MSTATUS_SD);
    addStorage(MSTATUS_SXL);
    addStorage(MSTATUS_UXL);
    addStorage(MSTATUS_TSR);
    addStorage(MSTATUS_TW);
    addStorage(MSTATUS_TVM);
    addStorage(MSTATUS_MXR);
    addStorage(MSTATUS_SUM);
    addStorage(MSTATUS_XS);
    addStorage(MSTATUS_FS);
    addStorage(MSTATUS_MPP);
    addStorage(MSTATUS_SPP);
    addStorage(MSTATUS_MPIE);
    addStorage(MSTATUS_SPIE);
    addStorage(MSTATUS_UPIE);
    addStorage(MSTATUS_MIE);
    addStorage(MSTATUS_SIE);
    addStorage(MSTATUS_UIE);
    addStorage(MISA_CSR);
    addStorage(MISA_U);
    addStorage(MISA_S);
    addStorage(MEDELEG_CSR);
    addStorage(MTVEC_CSR);
    addStorage(MEPC_CSR);
    addStorage(MCAUSE_CSR);
    addStorage(MTVAL_CSR);
    addStorage(DCSR_CSR);
    addStorage(DCSR_PRV);
    addStorage(DCSR_CAUSE);
    addStorage(DCSR_EBREAKU);
    addStorage(DCSR_EBREAKS);
    addStorage(DCSR_EBREAKM);
    addStorage(PRV);
    addStorage(DPC_CSR);
    addStorage(t_cause);
    addStorage(t_get_tval);
    addStorage(privilege_mode);
    addStorage(VREG);
  }

  @Override
  public ProcessingElement copy(final boolean shared) {
    return new PE(this, shared);
  }

  private static final class PEFactory implements Factory {
    @Override
    public PE create() {
      return new PE();
    }
  }

  public static Factory newFactory() {
    return new PEFactory();
  }
}
