/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv;

import java.math.BigInteger;
import ru.ispras.microtesk.model.TemporaryVariables;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.memory.Memory;

/**
 * The {@code TempVars} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class TempVars extends TemporaryVariables {
  public final Memory prev_pc;
  public final Memory tmp_address;
  public final Memory tmp_index;
  public final Memory tmp_bit;
  public final Memory tmp_byte;
  public final Memory tmp_half;
  public final Memory tmp_word;
  public final Memory tmp_dword;
  public final Memory tmp_dword1;
  public final Memory tmp_dword2;
  public final Memory tmp_qword;
  public final Memory tmp_int1;
  public final Memory tmp_int2;
  public final Memory tmp_long1;
  public final Memory tmp_long2;
  public final Memory mem_index;
  public final Memory temp_fps;
  public final Memory temp_fps2;
  public final Memory temp_fps3;
  public final Memory temp_fpd;
  public final Memory temp_fpd2;
  public final Memory temp_fpd3;
  public final Memory tmp_bit_offset;
  public final Memory opcode_xtype;
  public final Memory funct3;
  public final Memory funct7;
  public final Memory csr_index;
  public final Memory rd_var;
  public final Memory rs2_var;
  public final Memory temp_address_load;
  public final Memory temp_address_tail;
  public final Memory load_value;
  public final Memory bit;
  public final Memory deleg;
  public final Memory interrupt;
  public final Memory epc;
  public final Memory vector;
  public final Memory RoundingMode;
  public final Memory tmp_ui3;
  public final Memory sign_bit;
  public final Memory exponent;
  public final Memory precision;
  public final Memory sign_bit_d;
  public final Memory exponent_d;
  public final Memory precision_d;
  public final Memory jump_imm20;
  public final Memory jump_imm12;
  public final Memory c_jump_imm11;
  public final Memory c_jump_imm8;
  public final Memory v_funct7;
  public final Memory v_funct6;
  public final Memory v_funct5;
  public final Memory v_funct3;
  public final Memory v_vm;
  public final Memory v_temp;
  public final Memory v_long;
  public final Memory v_lumop;
  public final Memory v_sumop;
  public final Memory v_mop;
  public final Memory v_nf;
  public final Memory tmp_rv64m;
  public final Memory tmp_rv32m;
  public final Memory pc_alignment_mask;
  public final Memory npc;
  public final Memory tmp_delta;

  private TempVars() {
    this.prev_pc = Memory.def(Memory.Kind.VAR, "prev_pc", TypeDefs.XWORD, 1);
    this.tmp_address = Memory.def(Memory.Kind.VAR, "tmp_address", TypeDefs.XWORD, 1);
    this.tmp_index = Memory.def(Memory.Kind.VAR, "tmp_index", TypeDefs.XWORD, 1);
    this.tmp_bit = Memory.def(Memory.Kind.VAR, "tmp_bit", TypeDefs.BIT, 1);
    this.tmp_byte = Memory.def(Memory.Kind.VAR, "tmp_byte", TypeDefs.BYTE, 1);
    this.tmp_half = Memory.def(Memory.Kind.VAR, "tmp_half", TypeDefs.HWORD, 1);
    this.tmp_word = Memory.def(Memory.Kind.VAR, "tmp_word", TypeDefs.WORD, 1);
    this.tmp_dword = Memory.def(Memory.Kind.VAR, "tmp_dword", TypeDefs.DWORD, 1);
    this.tmp_dword1 = Memory.def(Memory.Kind.VAR, "tmp_dword1", TypeDefs.DWORD, 1);
    this.tmp_dword2 = Memory.def(Memory.Kind.VAR, "tmp_dword2", TypeDefs.DWORD, 1);
    this.tmp_qword = Memory.def(Memory.Kind.VAR, "tmp_qword", TypeDefs.QWORD, 1);
    this.tmp_int1 = Memory.def(Memory.Kind.VAR, "tmp_int1", TypeDefs.INT, 1);
    this.tmp_int2 = Memory.def(Memory.Kind.VAR, "tmp_int2", TypeDefs.INT, 1);
    this.tmp_long1 = Memory.def(Memory.Kind.VAR, "tmp_long1", TypeDefs.LONG, 1);
    this.tmp_long2 = Memory.def(Memory.Kind.VAR, "tmp_long2", TypeDefs.LONG, 1);
    this.mem_index = Memory.def(Memory.Kind.VAR, "mem_index", Type.CARD(53), 1);
    this.temp_fps = Memory.def(Memory.Kind.VAR, "temp_fps", TypeDefs.FLOAT32, 1);
    this.temp_fps2 = Memory.def(Memory.Kind.VAR, "temp_fps2", TypeDefs.FLOAT32, 1);
    this.temp_fps3 = Memory.def(Memory.Kind.VAR, "temp_fps3", TypeDefs.FLOAT32, 1);
    this.temp_fpd = Memory.def(Memory.Kind.VAR, "temp_fpd", TypeDefs.FLOAT64, 1);
    this.temp_fpd2 = Memory.def(Memory.Kind.VAR, "temp_fpd2", TypeDefs.FLOAT64, 1);
    this.temp_fpd3 = Memory.def(Memory.Kind.VAR, "temp_fpd3", TypeDefs.FLOAT64, 1);
    this.tmp_bit_offset = Memory.def(Memory.Kind.VAR, "tmp_bit_offset", Type.CARD(6), 1);
    this.opcode_xtype = Memory.def(Memory.Kind.VAR, "opcode_xtype", Type.CARD(7), 1);
    this.funct3 = Memory.def(Memory.Kind.VAR, "funct3", Type.CARD(3), 1);
    this.funct7 = Memory.def(Memory.Kind.VAR, "funct7", Type.CARD(7), 1);
    this.csr_index = Memory.def(Memory.Kind.VAR, "csr_index", Type.CARD(12), 1);
    this.rd_var = Memory.def(Memory.Kind.VAR, "rd_var", TypeDefs.XWORD, 1);
    this.rs2_var = Memory.def(Memory.Kind.VAR, "rs2_var", TypeDefs.XWORD, 1);
    this.temp_address_load = Memory.def(Memory.Kind.VAR, "temp_address_load", TypeDefs.DWORD, 1);
    this.temp_address_tail = Memory.def(Memory.Kind.VAR, "temp_address_tail", Type.CARD(2), 1);
    this.load_value = Memory.def(Memory.Kind.VAR, "load_value", TypeDefs.XWORD, 1);
    this.bit = Memory.def(Memory.Kind.VAR, "bit", TypeDefs.CSR_TYPE, 1);
    this.deleg = Memory.def(Memory.Kind.VAR, "deleg", TypeDefs.CSR_TYPE, 1);
    this.interrupt = Memory.def(Memory.Kind.VAR, "interrupt", TypeDefs.BIT, 1);
    this.epc = Memory.def(Memory.Kind.VAR, "epc", TypeDefs.CSR_TYPE, 1);
    this.vector = Memory.def(Memory.Kind.VAR, "vector", TypeDefs.CSR_TYPE, 1);
    this.RoundingMode = Memory.def(Memory.Kind.VAR, "RoundingMode", Type.CARD(3), 1);
    this.tmp_ui3 = Memory.def(Memory.Kind.VAR, "tmp_ui3", Type.CARD(3), 1);
    this.sign_bit = Memory.def(Memory.Kind.VAR, "sign_bit", TypeDefs.BIT, 1);
    this.exponent = Memory.def(Memory.Kind.VAR, "exponent", Type.CARD(8), 1);
    this.precision = Memory.def(Memory.Kind.VAR, "precision", Type.CARD(23), 1);
    this.sign_bit_d = Memory.def(Memory.Kind.VAR, "sign_bit_d", TypeDefs.BIT, 1);
    this.exponent_d = Memory.def(Memory.Kind.VAR, "exponent_d", Type.CARD(11), 1);
    this.precision_d = Memory.def(Memory.Kind.VAR, "precision_d", Type.CARD(52), 1);
    this.jump_imm20 = Memory.def(Memory.Kind.VAR, "jump_imm20", Type.CARD(20), 1);
    this.jump_imm12 = Memory.def(Memory.Kind.VAR, "jump_imm12", Type.CARD(12), 1);
    this.c_jump_imm11 = Memory.def(Memory.Kind.VAR, "c_jump_imm11", Type.CARD(11), 1);
    this.c_jump_imm8 = Memory.def(Memory.Kind.VAR, "c_jump_imm8", Type.CARD(8), 1);
    this.v_funct7 = Memory.def(Memory.Kind.VAR, "v_funct7", Type.CARD(7), 1);
    this.v_funct6 = Memory.def(Memory.Kind.VAR, "v_funct6", Type.CARD(6), 1);
    this.v_funct5 = Memory.def(Memory.Kind.VAR, "v_funct5", Type.CARD(5), 1);
    this.v_funct3 = Memory.def(Memory.Kind.VAR, "v_funct3", Type.CARD(3), 1);
    this.v_vm = Memory.def(Memory.Kind.VAR, "v_vm", TypeDefs.BIT, 1);
    this.v_temp = Memory.def(Memory.Kind.VAR, "v_temp", Type.CARD(32), 1);
    this.v_long = Memory.def(Memory.Kind.VAR, "v_long", TypeDefs.LONG, 1);
    this.v_lumop = Memory.def(Memory.Kind.VAR, "v_lumop", Type.CARD(5), 1);
    this.v_sumop = Memory.def(Memory.Kind.VAR, "v_sumop", Type.CARD(5), 1);
    this.v_mop = Memory.def(Memory.Kind.VAR, "v_mop", Type.CARD(3), 1);
    this.v_nf = Memory.def(Memory.Kind.VAR, "v_nf", Type.CARD(3), 1);
    this.tmp_rv64m = Memory.def(Memory.Kind.VAR, "tmp_rv64m", TypeDefs.XWORD, 1);
    this.tmp_rv32m = Memory.def(Memory.Kind.VAR, "tmp_rv32m", TypeDefs.XDWORD, 1);
    this.pc_alignment_mask = Memory.def(Memory.Kind.VAR, "pc_alignment_mask", TypeDefs.XWORD, 1);
    this.npc = Memory.def(Memory.Kind.VAR, "npc", TypeDefs.XWORD, 1);
    this.tmp_delta = Memory.def(Memory.Kind.VAR, "tmp_delta", Type.CARD(32), 1);

    addVariable(prev_pc);
    addVariable(tmp_address);
    addVariable(tmp_index);
    addVariable(tmp_bit);
    addVariable(tmp_byte);
    addVariable(tmp_half);
    addVariable(tmp_word);
    addVariable(tmp_dword);
    addVariable(tmp_dword1);
    addVariable(tmp_dword2);
    addVariable(tmp_qword);
    addVariable(tmp_int1);
    addVariable(tmp_int2);
    addVariable(tmp_long1);
    addVariable(tmp_long2);
    addVariable(mem_index);
    addVariable(temp_fps);
    addVariable(temp_fps2);
    addVariable(temp_fps3);
    addVariable(temp_fpd);
    addVariable(temp_fpd2);
    addVariable(temp_fpd3);
    addVariable(tmp_bit_offset);
    addVariable(opcode_xtype);
    addVariable(funct3);
    addVariable(funct7);
    addVariable(csr_index);
    addVariable(rd_var);
    addVariable(rs2_var);
    addVariable(temp_address_load);
    addVariable(temp_address_tail);
    addVariable(load_value);
    addVariable(bit);
    addVariable(deleg);
    addVariable(interrupt);
    addVariable(epc);
    addVariable(vector);
    addVariable(RoundingMode);
    addVariable(tmp_ui3);
    addVariable(sign_bit);
    addVariable(exponent);
    addVariable(precision);
    addVariable(sign_bit_d);
    addVariable(exponent_d);
    addVariable(precision_d);
    addVariable(jump_imm20);
    addVariable(jump_imm12);
    addVariable(c_jump_imm11);
    addVariable(c_jump_imm8);
    addVariable(v_funct7);
    addVariable(v_funct6);
    addVariable(v_funct5);
    addVariable(v_funct3);
    addVariable(v_vm);
    addVariable(v_temp);
    addVariable(v_long);
    addVariable(v_lumop);
    addVariable(v_sumop);
    addVariable(v_mop);
    addVariable(v_nf);
    addVariable(tmp_rv64m);
    addVariable(tmp_rv32m);
    addVariable(pc_alignment_mask);
    addVariable(npc);
    addVariable(tmp_delta);
  }

  private static final class TempVarsFactory implements Factory {
    @Override
    public TempVars create() {
      return new TempVars();
    }
  }

  public static Factory newFactory() {
    return new TempVarsFactory();
  }
}
