/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.branch_image;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.IsaPrimitive;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderBranch_image} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderBranch_image extends DecoderItem {
  private static DecoderBranch_image instance = null;

  public static DecoderBranch_image get() {
    if (null == instance) {
      instance = new DecoderBranch_image();
    }
    return instance;
  }

  private DecoderBranch_image() {
    super(
        32,
        true,
        "00000000000000000000000001100011",
        "00000000000000000000000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    X rs1 = null;
    X rs2 = null;
    IsaPrimitive imm = null;
    Immediate branch_index = null;

    imm = new Immediate(Type.CARD(12));
    imm.access().bitField(11, 11).store(readNextImmediate(image, Type.CARD(1)).access());
    imm.access().bitField(9, 4).store(readNextImmediate(image, Type.CARD(6)).access());
    rs2 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs2) {
      return null;
    }
    rs1 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs1) {
      return null;
    }
    branch_index = readNextImmediate(image, Type.CARD(3));
    imm.access().bitField(3, 0).store(readNextImmediate(image, Type.CARD(4)).access());
    imm.access().bitField(10, 10).store(readNextImmediate(image, Type.CARD(1)).access());
    if (!matchNextOpc(image, BitVector.valueOf("1100011", 2, 7))) {
      return null;
    }
    resetPosition();
    imm = (IsaPrimitive) readNextPrimitive(imm.access().load().getRawData(), DecoderBRANCH_OFFSET.get());
    if (null == imm) {
      return null;
    }

    return newResult(new branch_image(rs1, rs2, imm, branch_index));
  }
}
