/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.c_j;
import ru.ispras.microtesk.model.IsaPrimitive;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderC_j} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderC_j extends DecoderItem {
  private static DecoderC_j instance = null;

  public static DecoderC_j get() {
    if (null == instance) {
      instance = new DecoderC_j();
    }
    return instance;
  }

  private DecoderC_j() {
    super(
        16,
        true,
        "1010000000000001",
        "1110000000000011"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    IsaPrimitive target = null;

    if (!matchNextOpc(image, BitVector.valueOf("101", 2, 3))) {
      return null;
    }
    target = new Immediate(Type.CARD(11));
    target.access().bitField(10, 10).store(readNextImmediate(image, Type.CARD(1)).access());
    target.access().bitField(3, 3).store(readNextImmediate(image, Type.CARD(1)).access());
    target.access().bitField(8, 7).store(readNextImmediate(image, Type.CARD(2)).access());
    target.access().bitField(9, 9).store(readNextImmediate(image, Type.CARD(1)).access());
    target.access().bitField(5, 5).store(readNextImmediate(image, Type.CARD(1)).access());
    target.access().bitField(6, 6).store(readNextImmediate(image, Type.CARD(1)).access());
    target.access().bitField(2, 0).store(readNextImmediate(image, Type.CARD(3)).access());
    target.access().bitField(4, 4).store(readNextImmediate(image, Type.CARD(1)).access());
    if (!matchNextOpc(image, BitVector.valueOf("01", 2, 2))) {
      return null;
    }
    resetPosition();
    target = (IsaPrimitive) readNextPrimitive(target.access().load().getRawData(), DecoderC_JUMP_ADDR.get());
    if (null == target) {
      return null;
    }

    return newResult(new c_j(target));
  }
}
