/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.c_nop;
import ru.ispras.microtesk.model.riscv.mode.X;

/**
 * The {@code DecoderC_nop} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderC_nop extends DecoderItem {
  private static DecoderC_nop instance = null;

  public static DecoderC_nop get() {
    if (null == instance) {
      instance = new DecoderC_nop();
    }
    return instance;
  }

  private DecoderC_nop() {
    super(
        16,
        true,
        "0000000000000000",
        "1111111111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    if (!matchNextOpc(image, BitVector.valueOf("0000", 2, 4))) {
      return null;
    }
    final X X_instance;
    X_instance = (X) readNextPrimitive(image, DecoderX.get());
    if (null == X_instance) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("0000000", 2, 7))) {
      return null;
    }

    return newResult(new c_nop());
  }
}
