/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.csrrsi;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.IsaPrimitive;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderCsrrsi} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderCsrrsi extends DecoderItem {
  private static DecoderCsrrsi instance = null;

  public static DecoderCsrrsi get() {
    if (null == instance) {
      instance = new DecoderCsrrsi();
    }
    return instance;
  }

  private DecoderCsrrsi() {
    super(
        32,
        true,
        "00000000000000000110000001110011",
        "00000000000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    X rd = null;
    IsaPrimitive csr = null;
    Immediate imm = null;

    csr = (IsaPrimitive) readNextPrimitive(image, DecoderCSR_MODE.get());
    if (null == csr) {
      return null;
    }
    imm = readNextImmediate(image, Type.CARD(5));
    if (!matchNextOpc(image, BitVector.valueOf("110", 2, 3))) {
      return null;
    }
    rd = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("1110011", 2, 7))) {
      return null;
    }

    return newResult(new csrrsi(rd, csr, imm));
  }
}
