/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.fcvt_w_s2;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.riscv.mode.F;
import ru.ispras.microtesk.model.riscv.op.fcvt_w_s;

/**
 * The {@code DecoderFcvt_w_s2} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderFcvt_w_s2 extends DecoderItem {
  private static DecoderFcvt_w_s2 instance = null;

  public static DecoderFcvt_w_s2 get() {
    if (null == instance) {
      instance = new DecoderFcvt_w_s2();
    }
    return instance;
  }

  private DecoderFcvt_w_s2() {
    super(
        32,
        true,
        "11000000000000000001000001010011",
        "11111111111100000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    X rd = null;
    F rs1 = null;

    final fcvt_w_s fcvt_w_s_instance;
    fcvt_w_s_instance = (fcvt_w_s) readNextPrimitive(image, DecoderFcvt_w_s.get());
    if (null == fcvt_w_s_instance) {
      return null;
    }
    rd = fcvt_w_s_instance.rd;
    rs1 = fcvt_w_s_instance.rs1;

    return newResult(new fcvt_w_s2(rd, rs1));
  }
}
