/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.fcvt_wu_d;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.riscv.mode.F;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderFcvt_wu_d} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderFcvt_wu_d extends DecoderItem {
  private static DecoderFcvt_wu_d instance = null;

  public static DecoderFcvt_wu_d get() {
    if (null == instance) {
      instance = new DecoderFcvt_wu_d();
    }
    return instance;
  }

  private DecoderFcvt_wu_d() {
    super(
        32,
        true,
        "11000010000100000000000001010011",
        "11111111111100000000000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    X rd = null;
    F rs1 = null;
    Immediate op_round_mod = null;

    if (!matchNextOpc(image, BitVector.valueOf("1100001", 2, 7))) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("00001", 2, 5))) {
      return null;
    }
    rs1 = (F) readNextPrimitive(image, DecoderF.get());
    if (null == rs1) {
      return null;
    }
    op_round_mod = readNextImmediate(image, Type.CARD(3));
    rd = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("1010011", 2, 7))) {
      return null;
    }

    return newResult(new fcvt_wu_d(rd, rs1, op_round_mod));
  }
}
