/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.feq_s;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.riscv.mode.F;

/**
 * The {@code DecoderFeq_s} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderFeq_s extends DecoderItem {
  private static DecoderFeq_s instance = null;

  public static DecoderFeq_s get() {
    if (null == instance) {
      instance = new DecoderFeq_s();
    }
    return instance;
  }

  private DecoderFeq_s() {
    super(
        32,
        true,
        "10100000000000000010000001010011",
        "11111110000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    X rd = null;
    F rs1 = null;
    F rs2 = null;

    if (!matchNextOpc(image, BitVector.valueOf("1010000", 2, 7))) {
      return null;
    }
    rs2 = (F) readNextPrimitive(image, DecoderF.get());
    if (null == rs2) {
      return null;
    }
    rs1 = (F) readNextPrimitive(image, DecoderF.get());
    if (null == rs1) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("010", 2, 3))) {
      return null;
    }
    rd = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("1010011", 2, 7))) {
      return null;
    }

    return newResult(new feq_s(rd, rs1, rs2));
  }
}
