/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.fmv_d_x;
import ru.ispras.microtesk.model.riscv.mode.F;
import ru.ispras.microtesk.model.riscv.mode.X;

/**
 * The {@code DecoderFmv_d_x} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderFmv_d_x extends DecoderItem {
  private static DecoderFmv_d_x instance = null;

  public static DecoderFmv_d_x get() {
    if (null == instance) {
      instance = new DecoderFmv_d_x();
    }
    return instance;
  }

  private DecoderFmv_d_x() {
    super(
        32,
        true,
        "11110010000000000000000001010011",
        "11111111111100000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    F rd = null;
    X rs1 = null;

    if (!matchNextOpc(image, BitVector.valueOf("1111001", 2, 7))) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("00000", 2, 5))) {
      return null;
    }
    rs1 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs1) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("000", 2, 3))) {
      return null;
    }
    rd = (F) readNextPrimitive(image, DecoderF.get());
    if (null == rd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("1010011", 2, 7))) {
      return null;
    }

    return newResult(new fmv_d_x(rd, rs1));
  }
}
