/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.fnmadd_s;
import ru.ispras.microtesk.model.riscv.mode.F;

/**
 * The {@code DecoderFnmadd_s} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderFnmadd_s extends DecoderItem {
  private static DecoderFnmadd_s instance = null;

  public static DecoderFnmadd_s get() {
    if (null == instance) {
      instance = new DecoderFnmadd_s();
    }
    return instance;
  }

  private DecoderFnmadd_s() {
    super(
        32,
        true,
        "00000000000000000000000001001111",
        "00000110000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    F rd = null;
    F rs1 = null;
    F rs2 = null;
    F rs3 = null;

    rs3 = (F) readNextPrimitive(image, DecoderF.get());
    if (null == rs3) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("00", 2, 2))) {
      return null;
    }
    rs2 = (F) readNextPrimitive(image, DecoderF.get());
    if (null == rs2) {
      return null;
    }
    rs1 = (F) readNextPrimitive(image, DecoderF.get());
    if (null == rs1) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("000", 2, 3))) {
      return null;
    }
    rd = (F) readNextPrimitive(image, DecoderF.get());
    if (null == rd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("1001111", 2, 7))) {
      return null;
    }

    return newResult(new fnmadd_s(rd, rs1, rs2, rs3));
  }
}
