/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.HPMCOUNTER30;

/**
 * The {@code DecoderHPMCOUNTER30} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderHPMCOUNTER30 extends DecoderItem {
  private static DecoderHPMCOUNTER30 instance = null;

  public static DecoderHPMCOUNTER30 get() {
    if (null == instance) {
      instance = new DecoderHPMCOUNTER30();
    }
    return instance;
  }

  private DecoderHPMCOUNTER30() {
    super(
        12,
        true,
        "110000011110",
        "111111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    if (!matchNextOpc(image, BitVector.valueOf("110000011110", 2, 12))) {
      return null;
    }

    return newResult(new HPMCOUNTER30());
  }
}
