/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.sd;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderSd} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSd extends DecoderItem {
  private static DecoderSd instance = null;

  public static DecoderSd get() {
    if (null == instance) {
      instance = new DecoderSd();
    }
    return instance;
  }

  private DecoderSd() {
    super(
        32,
        true,
        "00000000000000000011000000100011",
        "00000000000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    X rs2 = null;
    X rs1 = null;
    Immediate imm = null;

    imm = new Immediate(Type.CARD(12));
    imm.access().bitField(11, 5).store(readNextImmediate(image, Type.CARD(7)).access());
    rs2 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs2) {
      return null;
    }
    rs1 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs1) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("011", 2, 3))) {
      return null;
    }
    imm.access().bitField(4, 0).store(readNextImmediate(image, Type.CARD(5)).access());
    if (!matchNextOpc(image, BitVector.valueOf("0100011", 2, 7))) {
      return null;
    }

    return newResult(new sd(rs2, rs1, imm));
  }
}
