/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.srai;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderSrai} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSrai extends DecoderItem {
  private static DecoderSrai instance = null;

  public static DecoderSrai get() {
    if (null == instance) {
      instance = new DecoderSrai();
    }
    return instance;
  }

  private DecoderSrai() {
    super(
        32,
        true,
        "01000000000000000101000000010011",
        "11111100000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    X rd = null;
    X rs1 = null;
    Immediate imm = null;

    if (!matchNextOpc(image, BitVector.valueOf("010000", 2, 6))) {
      return null;
    }
    imm = new Immediate(Type.CARD(6));
    imm.access().bitField(5, 5).store(readNextImmediate(image, Type.CARD(1)).access());
    imm.access().bitField(4, 0).store(readNextImmediate(image, Type.CARD(5)).access());
    rs1 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs1) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("101", 2, 3))) {
      return null;
    }
    rd = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("0010011", 2, 7))) {
      return null;
    }

    return newResult(new srai(rd, rs1, imm));
  }
}
