/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.vmul;
import ru.ispras.microtesk.model.riscv.mode.VR;

/**
 * The {@code DecoderVmul} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderVmul extends DecoderItem {
  private static DecoderVmul instance = null;

  public static DecoderVmul get() {
    if (null == instance) {
      instance = new DecoderVmul();
    }
    return instance;
  }

  private DecoderVmul() {
    super(
        32,
        true,
        "10010110000000000010000001010111",
        "11111110000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    VR vd = null;
    VR vs2 = null;
    VR vs1 = null;

    if (!matchNextOpc(image, BitVector.valueOf("100101", 2, 6))) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("1", 2, 1))) {
      return null;
    }
    vs2 = (VR) readNextPrimitive(image, DecoderVR.get());
    if (null == vs2) {
      return null;
    }
    vs1 = (VR) readNextPrimitive(image, DecoderVR.get());
    if (null == vs1) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("010", 2, 3))) {
      return null;
    }
    vd = (VR) readNextPrimitive(image, DecoderVR.get());
    if (null == vd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("1010111", 2, 7))) {
      return null;
    }

    return newResult(new vmul(vd, vs2, vs1));
  }
}
