/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.vsetvli;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderVsetvli} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderVsetvli extends DecoderItem {
  private static DecoderVsetvli instance = null;

  public static DecoderVsetvli get() {
    if (null == instance) {
      instance = new DecoderVsetvli();
    }
    return instance;
  }

  private DecoderVsetvli() {
    super(
        31,
        true,
        "0000000000000000111000001010111",
        "1111110000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    X rd = null;
    X rs1 = null;
    Immediate elements = null;
    Immediate vlmul = null;

    if (!matchNextOpc(image, BitVector.valueOf("0", 2, 1))) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("00000", 2, 5))) {
      return null;
    }
    elements = readNextImmediate(image, Type.CARD(3));
    vlmul = readNextImmediate(image, Type.CARD(2));
    rs1 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs1) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("111", 2, 3))) {
      return null;
    }
    rd = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("1010111", 2, 7))) {
      return null;
    }

    return newResult(new vsetvli(rd, rs1, elements, vlmul));
  }
}
