/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.vsw;
import ru.ispras.microtesk.model.riscv.mode.VR;
import ru.ispras.microtesk.model.riscv.mode.X;

/**
 * The {@code DecoderVsw} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderVsw extends DecoderItem {
  private static DecoderVsw instance = null;

  public static DecoderVsw get() {
    if (null == instance) {
      instance = new DecoderVsw();
    }
    return instance;
  }

  private DecoderVsw() {
    super(
        32,
        true,
        "00000010000000000110000000100111",
        "11111110000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    VR vs3 = null;
    X rs1 = null;

    if (!matchNextOpc(image, BitVector.valueOf("000", 2, 3))) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("000", 2, 3))) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("1", 2, 1))) {
      return null;
    }
    vars__.v_lumop.access().store(readNextImmediate(image, Type.CARD(5)).access());
    rs1 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs1) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("110", 2, 3))) {
      return null;
    }
    vs3 = (VR) readNextPrimitive(image, DecoderVR.get());
    if (null == vs3) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("0100111", 2, 7))) {
      return null;
    }

    return newResult(new vsw(vs3, rs1));
  }
}
