/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mmu.sim;

import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.mmu.model.sim.Data;

/**
 * The {@code PASv32} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PASv32 implements Data {
  public final BitVector ppn1;
  public final BitVector ppn0;
  public final BitVector offset;
  public final BitVector error;

  public PASv32() {
    this.ppn1 = BitVector.newEmpty(12);
    this.ppn0 = BitVector.newEmpty(10);
    this.offset = BitVector.newEmpty(12);
    this.error = BitVector.newEmpty(1);
  }

  public PASv32(final BitVector value) {
    this();
    asBitVector().assign(value);
  }

  public void assign(final PASv32 other) {
    this.ppn1.assign(other.ppn1);
    this.ppn0.assign(other.ppn0);
    this.offset.assign(other.offset);
    this.error.assign(other.error);
  }

  @Override
  public BitVector asBitVector() {
    return BitVector.newMapping(
        ppn1,
        ppn0,
        offset,
        error
        );
  }

  @Override
  public String toString() {
    return String.format(
        "PASv32 [ppn1=0x%s, ppn0=0x%s, offset=0x%s, error=0x%s]",
        ppn1.toHexString(),
        ppn0.toHexString(),
        offset.toHexString(),
        error.toHexString()
        );
  }
}
