/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mmu.sim;

import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.sim.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code PT48} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PT48 extends MmuMapping<PT48.Entry, VA> {
  private static PT48 instance = null;

  public static PT48 get() {
    if (null == instance) {
      instance = new PT48();
    }
    return instance;
  }

  public static final class Entry implements Data {
    public final BitVector reserved;
    public final BitVector ppn3;
    public final BitVector ppn2;
    public final BitVector ppn1;
    public final BitVector ppn0;
    public final BitVector rsw;
    public final BitVector d;
    public final BitVector a;
    public final BitVector g;
    public final BitVector u;
    public final BitVector x;
    public final BitVector w;
    public final BitVector r;
    public final BitVector v;

    public Entry() {
      this.reserved = BitVector.newEmpty(10);
      this.ppn3 = BitVector.newEmpty(17);
      this.ppn2 = BitVector.newEmpty(9);
      this.ppn1 = BitVector.newEmpty(9);
      this.ppn0 = BitVector.newEmpty(9);
      this.rsw = BitVector.newEmpty(2);
      this.d = BitVector.newEmpty(1);
      this.a = BitVector.newEmpty(1);
      this.g = BitVector.newEmpty(1);
      this.u = BitVector.newEmpty(1);
      this.x = BitVector.newEmpty(1);
      this.w = BitVector.newEmpty(1);
      this.r = BitVector.newEmpty(1);
      this.v = BitVector.newEmpty(1);
    }

    public Entry(final BitVector value) {
      this();
      asBitVector().assign(value);
    }

    public void assign(final Entry other) {
      this.reserved.assign(other.reserved);
      this.ppn3.assign(other.ppn3);
      this.ppn2.assign(other.ppn2);
      this.ppn1.assign(other.ppn1);
      this.ppn0.assign(other.ppn0);
      this.rsw.assign(other.rsw);
      this.d.assign(other.d);
      this.a.assign(other.a);
      this.g.assign(other.g);
      this.u.assign(other.u);
      this.x.assign(other.x);
      this.w.assign(other.w);
      this.r.assign(other.r);
      this.v.assign(other.v);
    }

    @Override
    public BitVector asBitVector() {
      return BitVector.newMapping(
          reserved,
          ppn3,
          ppn2,
          ppn1,
          ppn0,
          rsw,
          d,
          a,
          g,
          u,
          x,
          w,
          r,
          v
          );
    }

    @Override
    public String toString() {
      return String.format(
          "Entry [reserved=0x%s, ppn3=0x%s, ppn2=0x%s, ppn1=0x%s, ppn0=0x%s, rsw=0x%s, d=0x%s, a=0x%s, g=0x%s, u=0x%s, x=0x%s, w=0x%s, r=0x%s, v=0x%s]",
          reserved.toHexString(),
          ppn3.toHexString(),
          ppn2.toHexString(),
          ppn1.toHexString(),
          ppn0.toHexString(),
          rsw.toHexString(),
          d.toHexString(),
          a.toHexString(),
          g.toHexString(),
          u.toHexString(),
          x.toHexString(),
          w.toHexString(),
          r.toHexString(),
          v.toHexString()
          );
    }
  }
  private static final Indexer<VA> INDEXER = new Indexer<VA>() {
    @Override
    public BitVector getIndex(final VA va) {
      return BitVector.valueOf("0", 16, 158);
    }
  };

  private static final Matcher<PT48.Entry, VA> MATCHER = new Matcher<PT48.Entry, VA>() {
    @Override
    public boolean areMatching(final PT48.Entry data, final VA va) {
      return true;
    }
  };

  private PT48() {
    super(
      new BigInteger("512", 10),
      1,
      PolicyId.NONE,
      INDEXER,
      MATCHER
      );
  }

  @Override
  protected Mmu<VA> getMmu() {
    return memory.get();
  }

  @Override
  protected VA newAddress() {
    return new VA();
  }

  @Override
  protected Entry newData(final BitVector value) {
    return new Entry(value);
  }

  @Override
  protected int getDataBitSize() {
    return 64;
  }
}
