/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mmu.sim;

import java.math.BigInteger;
import ru.ispras.fortress.data.types.bitvector.*;
import ru.ispras.microtesk.model.Execution;

/**
 * The {@code PreTranslateAddress} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PreTranslateAddress {
  public static PA call(
    final VA va) {
    final PA pa = new PA();

    if (va.i_flag.equals(BitVector.valueOf(0x0, 1))) {
      va.i_flag.assign(BitVector.valueOf(0x1, 1));
      if (Extern.get().SATP_MODE().equals(BitVector.valueOf(0x8, 4))) {
        va.i.assign(BitVector.valueOf(0x2, 2));
      } else {
        va.i.assign(BitVector.valueOf(0x3, 2));
      }
    }
    if (!Extern.get().SATP_MODE().equals(BitVector.valueOf(0x0, 4))) {
      pa.assign(TranslateAddress.call(va));
    } else {
      pa.value.field(52, 0).assign(va.value);
      Execution.trace("Mmu.PreTranslateAddress: satp.mode=%s. No translation or protection.", Extern.get().SATP_MODE().toHexString());
    }
    return pa;
  }
}
