/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mmu.sim;

import java.math.BigInteger;
import ru.ispras.fortress.data.types.bitvector.*;
import ru.ispras.microtesk.model.Execution;

/**
 * The {@code SV39TranslateCycle} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class SV39TranslateCycle {
  public static PT39.Entry call(
    final VA va) {
    final PT39.Entry pte = new PT39.Entry();
    final BitVector a = BitVector.newEmpty(56);
    final BitVector temp = BitVector.newEmpty(56);
    final VA temp_va = new VA();
    final PTAddress temp_address = new PTAddress();

    temp.assign(BitVector.valueOf(0x0L, 56));
    if (va.i.equals(BitVector.valueOf(0x2, 2))) {
      temp.field(43, 0).assign(Extern.get().SATP_PPN());
      a.assign(BitVectorMath.shl(temp, BitVector.valueOf(0xCL, 56)));
      temp.assign(BitVector.valueOf(0x0L, 56));
      temp.field(8, 0).assign(va.value.field(38, 30));
    } else if (va.i.equals(BitVector.valueOf(0x1, 2))) {
      temp.field(43, 0).assign(va.ppn);
      a.assign(BitVectorMath.shl(temp, BitVector.valueOf(0xCL, 56)));
      temp.assign(BitVector.valueOf(0x0L, 56));
      temp.field(8, 0).assign(va.value.field(29, 21));
    } else if (va.i.equals(BitVector.valueOf(0x0, 2))) {
      temp.field(43, 0).assign(va.ppn);
      a.assign(BitVectorMath.shl(temp, BitVector.valueOf(0xCL, 56)));
      temp.assign(BitVector.valueOf(0x0L, 56));
      temp.field(8, 0).assign(va.value.field(20, 12));
    } else {
      Execution.trace("ERROR: the i must be in range [2,0]");
    }
    temp_address.value.assign(BitVectorMath.shl(temp, BitVector.valueOf(0x3L, 56)));
    temp_address.value.field(55, 12).assign(a.field(55, 12));
    temp_va.assign(va);
    temp_va.value.assign(BitVector.valueOf(0x0L, 53));
    temp_va.is_pa.assign(BitVector.valueOf(0x1, 1));
    temp_va.pa.assign(temp_address.value);
    pte.assign(PT39.get().getData(temp_va));
    if (pte.v.equals(BitVector.valueOf(0x0, 1))) {
      Execution.trace("SV39TranslateCycle: page-fault exception (pte.v = 0x%s)", pte.v.toHexString());
      Execution.exception("page_fault_exception");
    }
    if (pte.r.equals(BitVector.valueOf(0x0, 1)) && pte.w.equals(BitVector.valueOf(0x1, 1))) {
      Execution.trace("SV39TranslateCycle: page-fault exception (pte.r = 0x%s, pte.w = 0x%s)", pte.r.toHexString(), pte.w.toHexString());
      Execution.exception("page_fault_exception");
    }
    return pte;
  }
}
