/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mmu.sim;

import java.math.BigInteger;
import ru.ispras.fortress.data.types.bitvector.*;
import ru.ispras.microtesk.model.Execution;

/**
 * The {@code SV48Translate} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class SV48Translate {
  public static PA call(
    final VA va) {
    final PT48.Entry pte = new PT48.Entry();
    final PA pa = new PA();
    final BitVector a = BitVector.newEmpty(56);
    final BitVector temp = BitVector.newEmpty(56);

    pte.assign(SV48TranslateCycle.call(va));
    va.ppn.assign(BitVector.newMapping(pte.ppn3, BitVector.newMapping(pte.ppn2, BitVector.newMapping(pte.ppn1, pte.ppn0))));
    if (pte.r.equals(BitVector.valueOf(0x1, 1)) || pte.x.equals(BitVector.valueOf(0x1, 1))) {
      Execution.trace("Go step 5: (pte.r = 0x%s, pte.x = 0x%s)", pte.r.toHexString(), pte.x.toHexString());
    } else {
      va.i.assign(BitVector.valueOf(0x2, 2));
      pte.assign(SV48TranslateCycle.call(va));
      if (pte.r.equals(BitVector.valueOf(0x1, 1)) || pte.x.equals(BitVector.valueOf(0x1, 1))) {
        Execution.trace("Go step 5: (pte.r = 0x%s, pte.x = 0x%s)", pte.r.toHexString(), pte.x.toHexString());
      } else {
        va.i.assign(BitVector.valueOf(0x1, 2));
        pte.assign(SV48TranslateCycle.call(va));
        if (pte.r.equals(BitVector.valueOf(0x1, 1)) || pte.x.equals(BitVector.valueOf(0x1, 1))) {
          Execution.trace("Go step 5: (pte.r = 0x%s, pte.x = 0x%s)", pte.r.toHexString(), pte.x.toHexString());
        } else {
          va.i.assign(BitVector.valueOf(0x0, 2));
          pte.assign(SV48TranslateCycle.call(va));
          if (pte.r.equals(BitVector.valueOf(0x1, 1)) || pte.x.equals(BitVector.valueOf(0x1, 1))) {
            Execution.trace("Go step 5: (pte.r = 0x%s, pte.x = 0x%s)", pte.r.toHexString(), pte.x.toHexString());
          } else {
            Execution.trace("SV48Translate: page-fault exception (i < 0)");
            Execution.exception("page_fault_exception");
          }
        }
      }
    }
    if (va.i.equals(BitVector.valueOf(0x3, 2)) && !BitVector.newMapping(pte.ppn2, BitVector.newMapping(pte.ppn1, pte.ppn0)).equals(BitVector.valueOf(0x0, 27))) {
      Execution.trace("SV48Translate 6: page-fault exception (va.i = 0x%s)", va.i.toHexString());
      Execution.exception("page_fault_exception");
    }
    if (va.i.equals(BitVector.valueOf(0x2, 2)) && !BitVector.newMapping(pte.ppn1, pte.ppn0).equals(BitVector.valueOf(0x0, 18))) {
      Execution.trace("SV48Translate 6: page-fault exception (va.i = 0x%s)", va.i.toHexString());
      Execution.exception("page_fault_exception");
    }
    if (va.i.equals(BitVector.valueOf(0x1, 2)) && !pte.ppn0.equals(BitVector.valueOf(0x0, 9))) {
      Execution.trace("SV48Translate 6: page-fault exception (va.i = 0x%s)", va.i.toHexString());
      Execution.exception("page_fault_exception");
    }
    if (pte.a.equals(BitVector.valueOf(0x0, 1))) {
      Execution.trace("SV48Translate 7: page-fault exception (pte.a = 0x%s)", pte.a.toHexString());
      Execution.exception("page_fault_exception");
    }
    if (va.type.equals(BitVector.valueOf(0x1, 1)) && pte.d.equals(BitVector.valueOf(0x0, 1))) {
      Execution.trace("SV48Translate 7: page-fault exception (pte.d = 0x%s)", pte.d.toHexString());
      Execution.exception("page_fault_exception");
    }
    pa.value.field(11, 0).assign(va.value.field(11, 0));
    pa.value.field(55, 39).assign(pte.ppn3);
    pa.value.field(38, 30).assign(pte.ppn2);
    pa.value.field(29, 21).assign(pte.ppn1);
    pa.value.field(20, 12).assign(pte.ppn0);
    if (va.i.equals(BitVector.valueOf(0x3, 2))) {
      pa.value.field(38, 12).assign(va.value.field(38, 12));
    } else if (va.i.equals(BitVector.valueOf(0x2, 2))) {
      pa.value.field(29, 12).assign(va.value.field(29, 12));
    } else if (va.i.equals(BitVector.valueOf(0x1, 2))) {
      pa.value.field(20, 12).assign(va.value.field(20, 12));
    }
    return pa;
  }
}
