/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mmu.sim;

import java.math.BigInteger;
import ru.ispras.fortress.data.types.bitvector.*;
import ru.ispras.microtesk.model.Execution;

/**
 * The {@code TranslateAddress} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class TranslateAddress {
  public static PA call(
    final VA va) {
    final PA pa = new PA();

    if (va.is_pa.equals(BitVector.valueOf(0x1, 1))) {
      pa.value.assign(va.pa);
    } else {
      if (Extern.get().SATP_MODE().equals(BitVector.valueOf(0x8, 4))) {
        pa.assign(SV39Translate.call(va));
      } else if (Extern.get().SATP_MODE().equals(BitVector.valueOf(0x9, 4))) {
        pa.assign(SV48Translate.call(va));
      } else {
        Execution.trace("Mmu.TranslateAddress: Error. satp.mode=%s.", Extern.get().SATP_MODE().toHexString());
      }
    }
    return pa;
  }
}
