/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mmu.sim;

import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.mmu.model.sim.Data;
import ru.ispras.microtesk.mmu.model.sim.Address;

/**
 * The {@code VA} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class VA implements Data, Address {
  public final BitVector value;
  public final BitVector type;
  public final BitVector is_pa;
  public final BitVector i_flag;
  public final BitVector i;
  public final BitVector ppn;
  public final BitVector pa;

  public VA() {
    this.value = BitVector.newEmpty(53);
    this.type = BitVector.newEmpty(1);
    this.is_pa = BitVector.newEmpty(1);
    this.i_flag = BitVector.newEmpty(1);
    this.i = BitVector.newEmpty(2);
    this.ppn = BitVector.newEmpty(44);
    this.pa = BitVector.newEmpty(56);
  }

  public VA(final BitVector value) {
    this();
    asBitVector().assign(value);
  }

  public void assign(final VA other) {
    this.value.assign(other.value);
    this.type.assign(other.type);
    this.is_pa.assign(other.is_pa);
    this.i_flag.assign(other.i_flag);
    this.i.assign(other.i);
    this.ppn.assign(other.ppn);
    this.pa.assign(other.pa);
  }

  @Override
  public BitVector asBitVector() {
    return BitVector.newMapping(
        value,
        type,
        is_pa,
        i_flag,
        i,
        ppn,
        pa
        );
  }

  @Override
  public String toString() {
    return String.format(
        "VA [value=0x%s, type=0x%s, is_pa=0x%s, i_flag=0x%s, i=0x%s, ppn=0x%s, pa=0x%s]",
        value.toHexString(),
        type.toHexString(),
        is_pa.toHexString(),
        i_flag.toHexString(),
        i.toHexString(),
        ppn.toHexString(),
        pa.toHexString()
        );
  }

  @Override
  public BitVector getValue() {
    return value;
  }
}
