/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mmu.sim;

import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.mmu.model.sim.Data;

/**
 * The {@code VASv32} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class VASv32 implements Data {
  public final BitVector vpn1;
  public final BitVector vpn0;
  public final BitVector offset;

  public VASv32() {
    this.vpn1 = BitVector.newEmpty(10);
    this.vpn0 = BitVector.newEmpty(10);
    this.offset = BitVector.newEmpty(12);
  }

  public VASv32(final BitVector value) {
    this();
    asBitVector().assign(value);
  }

  public void assign(final VASv32 other) {
    this.vpn1.assign(other.vpn1);
    this.vpn0.assign(other.vpn0);
    this.offset.assign(other.offset);
  }

  @Override
  public BitVector asBitVector() {
    return BitVector.newMapping(
        vpn1,
        vpn0,
        offset
        );
  }

  @Override
  public String toString() {
    return String.format(
        "VASv32 [vpn1=0x%s, vpn0=0x%s, offset=0x%s]",
        vpn1.toHexString(),
        vpn0.toHexString(),
        offset.toHexString()
        );
  }
}
