/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mmu.sim;

import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.mmu.model.sim.Data;

/**
 * The {@code VASv39} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class VASv39 implements Data {
  public final BitVector vpn2;
  public final BitVector vpn1;
  public final BitVector vpn0;
  public final BitVector offset;

  public VASv39() {
    this.vpn2 = BitVector.newEmpty(9);
    this.vpn1 = BitVector.newEmpty(9);
    this.vpn0 = BitVector.newEmpty(9);
    this.offset = BitVector.newEmpty(12);
  }

  public VASv39(final BitVector value) {
    this();
    asBitVector().assign(value);
  }

  public void assign(final VASv39 other) {
    this.vpn2.assign(other.vpn2);
    this.vpn1.assign(other.vpn1);
    this.vpn0.assign(other.vpn0);
    this.offset.assign(other.offset);
  }

  @Override
  public BitVector asBitVector() {
    return BitVector.newMapping(
        vpn2,
        vpn1,
        vpn0,
        offset
        );
  }

  @Override
  public String toString() {
    return String.format(
        "VASv39 [vpn2=0x%s, vpn1=0x%s, vpn0=0x%s, offset=0x%s]",
        vpn2.toHexString(),
        vpn1.toHexString(),
        vpn0.toHexString(),
        offset.toHexString()
        );
  }
}
