/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mmu.sim;

import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.sim.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code memory} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class memory extends Mmu<VA> {
  private static memory instance = null;

  public static memory get() {
    if (null == instance) {
      instance = new memory();
    }
    return instance;
  }

  private memory() {}

  @Override
  public int getAddressBitSize() {
    return 53;
  }

  @Override
  public int getDataBitSize() {
    return 64;
  }

  @Override
  protected VA newAddress() {
    return new VA();
  }

  @Override
  public BitVector getData(final VA va) {
    final BitVector data = BitVector.newEmpty(64);

    final PA pa = new PA();

    pa.assign(PreTranslateAddress.call(va));
    data.assign(MEM.get().getData(pa).asBitVector());

    return data;
  }

  @Override
  public BitVector setData(final VA va, final BitVector data) {
    final PA pa = new PA();

    pa.assign(PreTranslateAddress.call(va));
    MEM.get().setData(pa).assign(data);

    return null;
  }
}
