/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mmu.spec;

import java.util.Collections;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.fortress.data.DataType;
import ru.ispras.fortress.expression.NodeVariable;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.fortress.expression.Nodes;
import ru.ispras.fortress.expression.NodeValue;
import ru.ispras.microtesk.mmu.model.spec.MmuBinding;
import ru.ispras.microtesk.mmu.model.spec.MmuBuffer;
import ru.ispras.microtesk.mmu.model.spec.MmuStruct;

/**
 * The {@code PT48} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PT48 extends MmuBuffer {
  private static PT48 INSTANCE = null;

  public static PT48 get() {
    if (null == INSTANCE) {
      INSTANCE = new PT48();
    }
    return INSTANCE;
  }

  private final VA va = VA.get();

  public static final class Entry extends MmuStruct {
    public final NodeVariable reserved;
    public final NodeVariable ppn3;
    public final NodeVariable ppn2;
    public final NodeVariable ppn1;
    public final NodeVariable ppn0;
    public final NodeVariable rsw;
    public final NodeVariable d;
    public final NodeVariable a;
    public final NodeVariable g;
    public final NodeVariable u;
    public final NodeVariable x;
    public final NodeVariable w;
    public final NodeVariable r;
    public final NodeVariable v;

    public Entry(final String name) {
      super(name);

      this.reserved = new NodeVariable(name + ".reserved", DataType.bitVector(10));
      this.ppn3 = new NodeVariable(name + ".ppn3", DataType.bitVector(17));
      this.ppn2 = new NodeVariable(name + ".ppn2", DataType.bitVector(9));
      this.ppn1 = new NodeVariable(name + ".ppn1", DataType.bitVector(9));
      this.ppn0 = new NodeVariable(name + ".ppn0", DataType.bitVector(9));
      this.rsw = new NodeVariable(name + ".rsw", DataType.bitVector(2));
      this.d = new NodeVariable(name + ".d", DataType.bitVector(1));
      this.a = new NodeVariable(name + ".a", DataType.bitVector(1));
      this.g = new NodeVariable(name + ".g", DataType.bitVector(1));
      this.u = new NodeVariable(name + ".u", DataType.bitVector(1));
      this.x = new NodeVariable(name + ".x", DataType.bitVector(1));
      this.w = new NodeVariable(name + ".w", DataType.bitVector(1));
      this.r = new NodeVariable(name + ".r", DataType.bitVector(1));
      this.v = new NodeVariable(name + ".v", DataType.bitVector(1));

      addField(reserved);
      addField(ppn3);
      addField(ppn2);
      addField(ppn1);
      addField(ppn0);
      addField(rsw);
      addField(d);
      addField(a);
      addField(g);
      addField(u);
      addField(x);
      addField(w);
      addField(r);
      addField(v);
    }
  }

  public final NodeVariable reserved;
  public final NodeVariable ppn3;
  public final NodeVariable ppn2;
  public final NodeVariable ppn1;
  public final NodeVariable ppn0;
  public final NodeVariable rsw;
  public final NodeVariable d;
  public final NodeVariable a;
  public final NodeVariable g;
  public final NodeVariable u;
  public final NodeVariable x;
  public final NodeVariable w;
  public final NodeVariable r;
  public final NodeVariable v;

  private PT48() {
    this("PT48");
  }

  private PT48(final String name) {
    super(
        name,
        Kind.MEMORY,
        1L,
        512L,
        VA.get(),
        Nodes.FALSE,
        Nodes.FALSE,
        Nodes.bvextract(52, 0, VA.get().value),
        Collections.<MmuBinding>emptyList(), // set up with setMatchBindings
        false,
        null
    );

    this.reserved = new NodeVariable(name + ".reserved", DataType.bitVector(10));
    this.ppn3 = new NodeVariable(name + ".ppn3", DataType.bitVector(17));
    this.ppn2 = new NodeVariable(name + ".ppn2", DataType.bitVector(9));
    this.ppn1 = new NodeVariable(name + ".ppn1", DataType.bitVector(9));
    this.ppn0 = new NodeVariable(name + ".ppn0", DataType.bitVector(9));
    this.rsw = new NodeVariable(name + ".rsw", DataType.bitVector(2));
    this.d = new NodeVariable(name + ".d", DataType.bitVector(1));
    this.a = new NodeVariable(name + ".a", DataType.bitVector(1));
    this.g = new NodeVariable(name + ".g", DataType.bitVector(1));
    this.u = new NodeVariable(name + ".u", DataType.bitVector(1));
    this.x = new NodeVariable(name + ".x", DataType.bitVector(1));
    this.w = new NodeVariable(name + ".w", DataType.bitVector(1));
    this.r = new NodeVariable(name + ".r", DataType.bitVector(1));
    this.v = new NodeVariable(name + ".v", DataType.bitVector(1));

    addField(reserved);
    addField(ppn3);
    addField(ppn2);
    addField(ppn1);
    addField(ppn0);
    addField(rsw);
    addField(d);
    addField(a);
    addField(g);
    addField(u);
    addField(x);
    addField(w);
    addField(r);
    addField(v);
  }
}
