/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mmu.spec;

import java.util.ArrayList;
import java.util.List;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.fortress.data.Data;
import ru.ispras.fortress.data.DataType;
import ru.ispras.fortress.data.Variable;
import ru.ispras.fortress.expression.NodeVariable;
import ru.ispras.fortress.expression.Nodes;
import ru.ispras.fortress.expression.NodeValue;
import ru.ispras.microtesk.mmu.model.spec.MmuSubsystem;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.mmu.basis.BufferAccessEvent;
import ru.ispras.microtesk.mmu.model.spec.MmuAction;
import ru.ispras.microtesk.mmu.model.spec.MmuBinding;
import ru.ispras.microtesk.mmu.model.spec.MmuBufferAccess;
import ru.ispras.microtesk.mmu.model.spec.MmuGuard;
import ru.ispras.microtesk.mmu.model.spec.MmuSegment;
import ru.ispras.microtesk.mmu.model.spec.MmuTransition;

/**
 * The {@code PreTranslateAddress} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PreTranslateAddress {
  private static PreTranslateAddress INSTANCE = null;

  public static PreTranslateAddress get() {
    if (null == INSTANCE) {
      INSTANCE = new PreTranslateAddress();
    }
    return INSTANCE;
  }

  private int callIndex = 0;

  public final Function newCall(
      final MmuSubsystem.Builder builder,
      final PA PreTranslateAddress,
      final VA va) {
    return new Function(builder, callIndex++, PreTranslateAddress, va);
  }

  public static final class Function {
    public final PA PreTranslateAddress;
    public final VA va;

    private final PA pa;


    public final MmuAction START;
    public final MmuAction STOP;

    private final MmuAction BRANCH_0;
    private final MmuAction ASSIGN_0;
    private final MmuAction BRANCH_1;
    private final MmuAction ASSIGN_1;
    private final MmuAction JOIN_0;
    private final MmuAction BRANCH_2;
    private final MmuAction ASSIGN_2;
    private final MmuAction JOIN_1;
    private final MmuAction BRANCH_3;
    private final MmuAction BRANCH_4;
    private final MmuAction ASSIGN_3;
    private final MmuAction JOIN_2;
    private final MmuAction BRANCH_5;
    private final MmuAction ASSIGN_4;
    private final MmuAction ASSIGN_5;

    private Function(
        final MmuSubsystem.Builder builder,
        final int instanceIndex,
        final PA PreTranslateAddress,
        final VA va) {
      final String name = String.format("PreTranslateAddress_%d", instanceIndex);
      this.PreTranslateAddress = PreTranslateAddress; 
      this.va = va; 

      this.pa = new PA(name + ".pa");
      builder.registerVariable(pa);

      this.START = new MmuAction(name + ".START");
      builder.registerAction(START);
      this.STOP = new MmuAction(name + ".STOP");
      builder.registerAction(STOP);

      this.BRANCH_0 = new MmuAction(name + ".BRANCH_0");
      builder.registerAction(BRANCH_0);
      builder.registerTransition(new MmuTransition(START, BRANCH_0, new MmuGuard(Nodes.eq(va.i_flag, NodeValue.newBitVector(0x0, 1)))));
      this.ASSIGN_0 = new MmuAction(name + ".ASSIGN_0", new MmuBinding(va.i_flag, NodeValue.newInteger(1)));
      builder.registerAction(ASSIGN_0);
      builder.registerTransition(new MmuTransition(BRANCH_0, ASSIGN_0));
      this.BRANCH_1 = new MmuAction(name + ".BRANCH_1");
      builder.registerAction(BRANCH_1);
      builder.registerTransition(new MmuTransition(ASSIGN_0, BRANCH_1, new MmuGuard(Nodes.eq(SATP_MODE.get(), NodeValue.newBitVector(0x8, 4)))));
      this.ASSIGN_1 = new MmuAction(name + ".ASSIGN_1", new MmuBinding(va.i, NodeValue.newInteger(2)));
      builder.registerAction(ASSIGN_1);
      builder.registerTransition(new MmuTransition(BRANCH_1, ASSIGN_1));
      this.JOIN_0 = new MmuAction(name + ".JOIN_0");
      builder.registerAction(JOIN_0);
      builder.registerTransition(new MmuTransition(ASSIGN_1, JOIN_0));
      this.BRANCH_2 = new MmuAction(name + ".BRANCH_2");
      builder.registerAction(BRANCH_2);
      builder.registerTransition(new MmuTransition(ASSIGN_0, BRANCH_2, new MmuGuard(Nodes.noteq(SATP_MODE.get(), NodeValue.newBitVector(0x8, 4)))));
      this.ASSIGN_2 = new MmuAction(name + ".ASSIGN_2", new MmuBinding(va.i, NodeValue.newInteger(3)));
      builder.registerAction(ASSIGN_2);
      builder.registerTransition(new MmuTransition(BRANCH_2, ASSIGN_2));
      builder.registerTransition(new MmuTransition(ASSIGN_2, JOIN_0));
      this.JOIN_1 = new MmuAction(name + ".JOIN_1");
      builder.registerAction(JOIN_1);
      builder.registerTransition(new MmuTransition(JOIN_0, JOIN_1));
      this.BRANCH_3 = new MmuAction(name + ".BRANCH_3");
      builder.registerAction(BRANCH_3);
      builder.registerTransition(new MmuTransition(START, BRANCH_3, new MmuGuard(Nodes.noteq(va.i_flag, NodeValue.newBitVector(0x0, 1)))));
      builder.registerTransition(new MmuTransition(BRANCH_3, JOIN_1));
      this.BRANCH_4 = new MmuAction(name + ".BRANCH_4");
      builder.registerAction(BRANCH_4);
      builder.registerTransition(new MmuTransition(JOIN_1, BRANCH_4, new MmuGuard(Nodes.noteq(SATP_MODE.get(), NodeValue.newBitVector(0x0, 4)))));
      final PA TMP_0 = new PA(name + ".TMP_0");
      TranslateAddress.Function call_0 = TranslateAddress.get().newCall(builder, TMP_0, va);
      builder.registerTransition(new MmuTransition(BRANCH_4, call_0.START));
      this.ASSIGN_3 = new MmuAction(name + ".ASSIGN_3", pa, TMP_0);
      builder.registerAction(ASSIGN_3);
      builder.registerTransition(new MmuTransition(call_0.STOP, ASSIGN_3));
      this.JOIN_2 = new MmuAction(name + ".JOIN_2");
      builder.registerAction(JOIN_2);
      builder.registerTransition(new MmuTransition(ASSIGN_3, JOIN_2));
      this.BRANCH_5 = new MmuAction(name + ".BRANCH_5");
      builder.registerAction(BRANCH_5);
      builder.registerTransition(new MmuTransition(JOIN_1, BRANCH_5, new MmuGuard(Nodes.eq(SATP_MODE.get(), NodeValue.newBitVector(0x0, 4)))));
      this.ASSIGN_4 = new MmuAction(name + ".ASSIGN_4", new MmuBinding(Nodes.bvextract(52, 0, pa.value), va.value));
      builder.registerAction(ASSIGN_4);
      builder.registerTransition(new MmuTransition(BRANCH_5, ASSIGN_4));
      builder.registerTransition(new MmuTransition(ASSIGN_4, JOIN_2));
      this.ASSIGN_5 = new MmuAction(name + ".ASSIGN_5", PreTranslateAddress, pa);
      builder.registerAction(ASSIGN_5);
      builder.registerTransition(new MmuTransition(JOIN_2, ASSIGN_5));
      builder.registerTransition(new MmuTransition(ASSIGN_5, STOP));
    }
  }
}
