/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mmu.spec;

import java.util.ArrayList;
import java.util.List;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.fortress.data.Data;
import ru.ispras.fortress.data.DataType;
import ru.ispras.fortress.data.Variable;
import ru.ispras.fortress.expression.NodeVariable;
import ru.ispras.fortress.expression.Nodes;
import ru.ispras.fortress.expression.NodeValue;
import ru.ispras.microtesk.mmu.model.spec.MmuSubsystem;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.mmu.basis.BufferAccessEvent;
import ru.ispras.microtesk.mmu.model.spec.MmuAction;
import ru.ispras.microtesk.mmu.model.spec.MmuBinding;
import ru.ispras.microtesk.mmu.model.spec.MmuBufferAccess;
import ru.ispras.microtesk.mmu.model.spec.MmuGuard;
import ru.ispras.microtesk.mmu.model.spec.MmuSegment;
import ru.ispras.microtesk.mmu.model.spec.MmuTransition;

/**
 * The {@code SV39TranslateCycle} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class SV39TranslateCycle {
  private static SV39TranslateCycle INSTANCE = null;

  public static SV39TranslateCycle get() {
    if (null == INSTANCE) {
      INSTANCE = new SV39TranslateCycle();
    }
    return INSTANCE;
  }

  private int callIndex = 0;

  public final Function newCall(
      final MmuSubsystem.Builder builder,
      final PT39.Entry SV39TranslateCycle,
      final VA va) {
    return new Function(builder, callIndex++, SV39TranslateCycle, va);
  }

  public static final class Function {
    public final PT39.Entry SV39TranslateCycle;
    public final VA va;

    private final PT39.Entry pte;
    private final NodeVariable a;
    private final NodeVariable temp;
    private final VA temp_va;
    private final PTAddress temp_address;


    public final MmuAction START;
    public final MmuAction STOP;

    private final MmuAction ASSIGN_0;
    private final MmuAction BRANCH_0;
    private final MmuAction ASSIGN_1;
    private final MmuAction ASSIGN_2;
    private final MmuAction ASSIGN_3;
    private final MmuAction ASSIGN_4;
    private final MmuAction JOIN_0;
    private final MmuAction BRANCH_1;
    private final MmuAction ASSIGN_5;
    private final MmuAction ASSIGN_6;
    private final MmuAction ASSIGN_7;
    private final MmuAction ASSIGN_8;
    private final MmuAction BRANCH_2;
    private final MmuAction ASSIGN_9;
    private final MmuAction ASSIGN_10;
    private final MmuAction ASSIGN_11;
    private final MmuAction ASSIGN_12;
    private final MmuAction BRANCH_3;
    private final MmuAction ASSIGN_13;
    private final MmuAction ASSIGN_14;
    private final MmuAction ASSIGN_15;
    private final MmuAction ASSIGN_16;
    private final MmuAction ASSIGN_17;
    private final MmuAction ASSIGN_18;
    private final MmuAction ASSIGN_19;
    private final MmuAction BRANCH_4;
    private final MmuAction page_fault_exception;
    private final MmuAction BRANCH_5;
    private final MmuAction BRANCH_6;
    private final MmuAction BRANCH_7;
    private final MmuAction ASSIGN_20;

    private Function(
        final MmuSubsystem.Builder builder,
        final int instanceIndex,
        final PT39.Entry SV39TranslateCycle,
        final VA va) {
      final String name = String.format("SV39TranslateCycle_%d", instanceIndex);
      this.SV39TranslateCycle = SV39TranslateCycle; 
      this.va = va; 

      this.pte = new PT39.Entry(name + ".pte");
      builder.registerVariable(pte);
      this.a = new NodeVariable(name + ".a", DataType.bitVector(56));
      builder.registerVariable(a);
      this.temp = new NodeVariable(name + ".temp", DataType.bitVector(56));
      builder.registerVariable(temp);
      this.temp_va = new VA(name + ".temp_va");
      builder.registerVariable(temp_va);
      this.temp_address = new PTAddress(name + ".temp_address");
      builder.registerVariable(temp_address);

      this.START = new MmuAction(name + ".START");
      builder.registerAction(START);
      this.STOP = new MmuAction(name + ".STOP");
      builder.registerAction(STOP);

      this.ASSIGN_0 = new MmuAction(name + ".ASSIGN_0", new MmuBinding(temp, NodeValue.newInteger(0)));
      builder.registerAction(ASSIGN_0);
      builder.registerTransition(new MmuTransition(START, ASSIGN_0));
      this.BRANCH_0 = new MmuAction(name + ".BRANCH_0");
      builder.registerAction(BRANCH_0);
      builder.registerTransition(new MmuTransition(ASSIGN_0, BRANCH_0, new MmuGuard(Nodes.eq(va.i, NodeValue.newBitVector(0x2, 2)))));
      this.ASSIGN_1 = new MmuAction(name + ".ASSIGN_1", new MmuBinding(Nodes.bvextract(43, 0, temp), SATP_PPN.get()));
      builder.registerAction(ASSIGN_1);
      builder.registerTransition(new MmuTransition(BRANCH_0, ASSIGN_1));
      this.ASSIGN_2 = new MmuAction(name + ".ASSIGN_2", new MmuBinding(a, Nodes.bvconcat(Nodes.bvextract(43, 0, temp), NodeValue.newBitVector(0x0, 12))));
      builder.registerAction(ASSIGN_2);
      builder.registerTransition(new MmuTransition(ASSIGN_1, ASSIGN_2));
      this.ASSIGN_3 = new MmuAction(name + ".ASSIGN_3", new MmuBinding(temp, NodeValue.newInteger(0)));
      builder.registerAction(ASSIGN_3);
      builder.registerTransition(new MmuTransition(ASSIGN_2, ASSIGN_3));
      this.ASSIGN_4 = new MmuAction(name + ".ASSIGN_4", new MmuBinding(Nodes.bvextract(8, 0, temp), Nodes.bvextract(38, 30, va.value)));
      builder.registerAction(ASSIGN_4);
      builder.registerTransition(new MmuTransition(ASSIGN_3, ASSIGN_4));
      this.JOIN_0 = new MmuAction(name + ".JOIN_0");
      builder.registerAction(JOIN_0);
      builder.registerTransition(new MmuTransition(ASSIGN_4, JOIN_0));
      this.BRANCH_1 = new MmuAction(name + ".BRANCH_1");
      builder.registerAction(BRANCH_1);
      builder.registerTransition(new MmuTransition(ASSIGN_0, BRANCH_1, new MmuGuard(Nodes.eq(va.i, NodeValue.newBitVector(0x1, 2)))));
      this.ASSIGN_5 = new MmuAction(name + ".ASSIGN_5", new MmuBinding(Nodes.bvextract(43, 0, temp), va.ppn));
      builder.registerAction(ASSIGN_5);
      builder.registerTransition(new MmuTransition(BRANCH_1, ASSIGN_5));
      this.ASSIGN_6 = new MmuAction(name + ".ASSIGN_6", new MmuBinding(a, Nodes.bvconcat(Nodes.bvextract(43, 0, temp), NodeValue.newBitVector(0x0, 12))));
      builder.registerAction(ASSIGN_6);
      builder.registerTransition(new MmuTransition(ASSIGN_5, ASSIGN_6));
      this.ASSIGN_7 = new MmuAction(name + ".ASSIGN_7", new MmuBinding(temp, NodeValue.newInteger(0)));
      builder.registerAction(ASSIGN_7);
      builder.registerTransition(new MmuTransition(ASSIGN_6, ASSIGN_7));
      this.ASSIGN_8 = new MmuAction(name + ".ASSIGN_8", new MmuBinding(Nodes.bvextract(8, 0, temp), Nodes.bvextract(29, 21, va.value)));
      builder.registerAction(ASSIGN_8);
      builder.registerTransition(new MmuTransition(ASSIGN_7, ASSIGN_8));
      builder.registerTransition(new MmuTransition(ASSIGN_8, JOIN_0));
      this.BRANCH_2 = new MmuAction(name + ".BRANCH_2");
      builder.registerAction(BRANCH_2);
      builder.registerTransition(new MmuTransition(ASSIGN_0, BRANCH_2, new MmuGuard(Nodes.eq(va.i, NodeValue.newBitVector(0x0, 2)))));
      this.ASSIGN_9 = new MmuAction(name + ".ASSIGN_9", new MmuBinding(Nodes.bvextract(43, 0, temp), va.ppn));
      builder.registerAction(ASSIGN_9);
      builder.registerTransition(new MmuTransition(BRANCH_2, ASSIGN_9));
      this.ASSIGN_10 = new MmuAction(name + ".ASSIGN_10", new MmuBinding(a, Nodes.bvconcat(Nodes.bvextract(43, 0, temp), NodeValue.newBitVector(0x0, 12))));
      builder.registerAction(ASSIGN_10);
      builder.registerTransition(new MmuTransition(ASSIGN_9, ASSIGN_10));
      this.ASSIGN_11 = new MmuAction(name + ".ASSIGN_11", new MmuBinding(temp, NodeValue.newInteger(0)));
      builder.registerAction(ASSIGN_11);
      builder.registerTransition(new MmuTransition(ASSIGN_10, ASSIGN_11));
      this.ASSIGN_12 = new MmuAction(name + ".ASSIGN_12", new MmuBinding(Nodes.bvextract(8, 0, temp), Nodes.bvextract(20, 12, va.value)));
      builder.registerAction(ASSIGN_12);
      builder.registerTransition(new MmuTransition(ASSIGN_11, ASSIGN_12));
      builder.registerTransition(new MmuTransition(ASSIGN_12, JOIN_0));
      this.BRANCH_3 = new MmuAction(name + ".BRANCH_3");
      builder.registerAction(BRANCH_3);
      builder.registerTransition(new MmuTransition(ASSIGN_0, BRANCH_3, new MmuGuard(Nodes.and(Nodes.noteq(va.i, NodeValue.newBitVector(0x2, 2)), Nodes.noteq(va.i, NodeValue.newBitVector(0x1, 2)), Nodes.noteq(va.i, NodeValue.newBitVector(0x0, 2))))));
      builder.registerTransition(new MmuTransition(BRANCH_3, JOIN_0));
      this.ASSIGN_13 = new MmuAction(name + ".ASSIGN_13", new MmuBinding(temp_address.value, Nodes.bvconcat(Nodes.bvextract(52, 0, temp), NodeValue.newBitVector(0x0, 3))));
      builder.registerAction(ASSIGN_13);
      builder.registerTransition(new MmuTransition(JOIN_0, ASSIGN_13));
      this.ASSIGN_14 = new MmuAction(name + ".ASSIGN_14", new MmuBinding(Nodes.bvextract(55, 12, temp_address.value), Nodes.bvextract(55, 12, a)));
      builder.registerAction(ASSIGN_14);
      builder.registerTransition(new MmuTransition(ASSIGN_13, ASSIGN_14));
      this.ASSIGN_15 = new MmuAction(name + ".ASSIGN_15", temp_va, va);
      builder.registerAction(ASSIGN_15);
      builder.registerTransition(new MmuTransition(ASSIGN_14, ASSIGN_15));
      this.ASSIGN_16 = new MmuAction(name + ".ASSIGN_16", new MmuBinding(temp_va.value, NodeValue.newInteger(0)));
      builder.registerAction(ASSIGN_16);
      builder.registerTransition(new MmuTransition(ASSIGN_15, ASSIGN_16));
      this.ASSIGN_17 = new MmuAction(name + ".ASSIGN_17", new MmuBinding(temp_va.is_pa, NodeValue.newInteger(1)));
      builder.registerAction(ASSIGN_17);
      builder.registerTransition(new MmuTransition(ASSIGN_16, ASSIGN_17));
      this.ASSIGN_18 = new MmuAction(name + ".ASSIGN_18", new MmuBinding(temp_va.pa, temp_address.value));
      builder.registerAction(ASSIGN_18);
      builder.registerTransition(new MmuTransition(ASSIGN_17, ASSIGN_18));
      this.ASSIGN_19 = new MmuAction(name + ".ASSIGN_19", new MmuBufferAccess(PT39.get(), BufferAccessEvent.READ, PT39.get().getAddress(), PT39.get(), temp_va), pte, PT39.get());
      builder.registerAction(ASSIGN_19);
      builder.registerTransition(new MmuTransition(ASSIGN_18, ASSIGN_19));
      this.BRANCH_4 = new MmuAction(name + ".BRANCH_4");
      builder.registerAction(BRANCH_4);
      builder.registerTransition(new MmuTransition(ASSIGN_19, BRANCH_4, new MmuGuard(Nodes.eq(pte.v, NodeValue.newBitVector(0x0, 1)))));
      this.page_fault_exception = new MmuAction(name + ".page_fault_exception", true);
      builder.registerAction(page_fault_exception);
      builder.registerTransition(new MmuTransition(BRANCH_4, page_fault_exception));
      this.BRANCH_5 = new MmuAction(name + ".BRANCH_5");
      builder.registerAction(BRANCH_5);
      builder.registerTransition(new MmuTransition(ASSIGN_19, BRANCH_5, new MmuGuard(Nodes.noteq(pte.v, NodeValue.newBitVector(0x0, 1)))));
      this.BRANCH_6 = new MmuAction(name + ".BRANCH_6");
      builder.registerAction(BRANCH_6);
      builder.registerTransition(new MmuTransition(BRANCH_5, BRANCH_6, new MmuGuard(Nodes.and(Nodes.eq(pte.r, NodeValue.newBitVector(0x0, 1)), Nodes.eq(pte.w, NodeValue.newBitVector(0x1, 1))))));
      builder.registerTransition(new MmuTransition(BRANCH_6, page_fault_exception));
      this.BRANCH_7 = new MmuAction(name + ".BRANCH_7");
      builder.registerAction(BRANCH_7);
      builder.registerTransition(new MmuTransition(BRANCH_5, BRANCH_7, new MmuGuard(Nodes.or(Nodes.noteq(pte.r, NodeValue.newBitVector(0x0, 1)), Nodes.noteq(pte.w, NodeValue.newBitVector(0x1, 1))))));
      this.ASSIGN_20 = new MmuAction(name + ".ASSIGN_20", SV39TranslateCycle, pte);
      builder.registerAction(ASSIGN_20);
      builder.registerTransition(new MmuTransition(BRANCH_7, ASSIGN_20));
      builder.registerTransition(new MmuTransition(ASSIGN_20, STOP));
    }
  }
}
