/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mmu.spec;

import java.util.ArrayList;
import java.util.List;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.fortress.data.Data;
import ru.ispras.fortress.data.DataType;
import ru.ispras.fortress.data.Variable;
import ru.ispras.fortress.expression.NodeVariable;
import ru.ispras.fortress.expression.Nodes;
import ru.ispras.fortress.expression.NodeValue;
import ru.ispras.microtesk.mmu.model.spec.MmuSubsystem;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.mmu.basis.BufferAccessEvent;
import ru.ispras.microtesk.mmu.model.spec.MmuAction;
import ru.ispras.microtesk.mmu.model.spec.MmuBinding;
import ru.ispras.microtesk.mmu.model.spec.MmuBufferAccess;
import ru.ispras.microtesk.mmu.model.spec.MmuGuard;
import ru.ispras.microtesk.mmu.model.spec.MmuSegment;
import ru.ispras.microtesk.mmu.model.spec.MmuTransition;

/**
 * The {@code SV48Translate} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class SV48Translate {
  private static SV48Translate INSTANCE = null;

  public static SV48Translate get() {
    if (null == INSTANCE) {
      INSTANCE = new SV48Translate();
    }
    return INSTANCE;
  }

  private int callIndex = 0;

  public final Function newCall(
      final MmuSubsystem.Builder builder,
      final PA SV48Translate,
      final VA va) {
    return new Function(builder, callIndex++, SV48Translate, va);
  }

  public static final class Function {
    public final PA SV48Translate;
    public final VA va;

    private final PT48.Entry pte;
    private final PA pa;
    private final NodeVariable a;
    private final NodeVariable temp;


    public final MmuAction START;
    public final MmuAction STOP;

    private final MmuAction ASSIGN_0;
    private final MmuAction ASSIGN_1;
    private final MmuAction BRANCH_0;
    private final MmuAction JOIN_0;
    private final MmuAction BRANCH_1;
    private final MmuAction ASSIGN_2;
    private final MmuAction ASSIGN_3;
    private final MmuAction BRANCH_2;
    private final MmuAction JOIN_1;
    private final MmuAction BRANCH_3;
    private final MmuAction ASSIGN_4;
    private final MmuAction ASSIGN_5;
    private final MmuAction BRANCH_4;
    private final MmuAction JOIN_2;
    private final MmuAction BRANCH_5;
    private final MmuAction ASSIGN_6;
    private final MmuAction ASSIGN_7;
    private final MmuAction BRANCH_6;
    private final MmuAction JOIN_3;
    private final MmuAction BRANCH_7;
    private final MmuAction page_fault_exception;
    private final MmuAction BRANCH_8;
    private final MmuAction BRANCH_9;
    private final MmuAction BRANCH_10;
    private final MmuAction BRANCH_11;
    private final MmuAction BRANCH_12;
    private final MmuAction BRANCH_13;
    private final MmuAction BRANCH_14;
    private final MmuAction BRANCH_15;
    private final MmuAction BRANCH_16;
    private final MmuAction BRANCH_17;
    private final MmuAction ASSIGN_8;
    private final MmuAction ASSIGN_9;
    private final MmuAction ASSIGN_10;
    private final MmuAction ASSIGN_11;
    private final MmuAction ASSIGN_12;
    private final MmuAction BRANCH_18;
    private final MmuAction ASSIGN_13;
    private final MmuAction JOIN_4;
    private final MmuAction BRANCH_19;
    private final MmuAction ASSIGN_14;
    private final MmuAction BRANCH_20;
    private final MmuAction ASSIGN_15;
    private final MmuAction BRANCH_21;
    private final MmuAction ASSIGN_16;

    private Function(
        final MmuSubsystem.Builder builder,
        final int instanceIndex,
        final PA SV48Translate,
        final VA va) {
      final String name = String.format("SV48Translate_%d", instanceIndex);
      this.SV48Translate = SV48Translate; 
      this.va = va; 

      this.pte = new PT48.Entry(name + ".pte");
      builder.registerVariable(pte);
      this.pa = new PA(name + ".pa");
      builder.registerVariable(pa);
      this.a = new NodeVariable(name + ".a", DataType.bitVector(56));
      builder.registerVariable(a);
      this.temp = new NodeVariable(name + ".temp", DataType.bitVector(56));
      builder.registerVariable(temp);

      this.START = new MmuAction(name + ".START");
      builder.registerAction(START);
      this.STOP = new MmuAction(name + ".STOP");
      builder.registerAction(STOP);

      final PT48.Entry TMP_0 = new PT48.Entry(name + ".TMP_0");
      SV48TranslateCycle.Function call_0 = SV48TranslateCycle.get().newCall(builder, TMP_0, va);
      builder.registerTransition(new MmuTransition(START, call_0.START));
      this.ASSIGN_0 = new MmuAction(name + ".ASSIGN_0", pte, TMP_0);
      builder.registerAction(ASSIGN_0);
      builder.registerTransition(new MmuTransition(call_0.STOP, ASSIGN_0));
      this.ASSIGN_1 = new MmuAction(name + ".ASSIGN_1", new MmuBinding(va.ppn, Nodes.bvconcat(pte.ppn3, Nodes.bvconcat(pte.ppn2, Nodes.bvconcat(pte.ppn1, pte.ppn0)))));
      builder.registerAction(ASSIGN_1);
      builder.registerTransition(new MmuTransition(ASSIGN_0, ASSIGN_1));
      this.BRANCH_0 = new MmuAction(name + ".BRANCH_0");
      builder.registerAction(BRANCH_0);
      builder.registerTransition(new MmuTransition(ASSIGN_1, BRANCH_0, new MmuGuard(Nodes.or(Nodes.eq(pte.r, NodeValue.newBitVector(0x1, 1)), Nodes.eq(pte.x, NodeValue.newBitVector(0x1, 1))))));
      this.JOIN_0 = new MmuAction(name + ".JOIN_0");
      builder.registerAction(JOIN_0);
      builder.registerTransition(new MmuTransition(BRANCH_0, JOIN_0));
      this.BRANCH_1 = new MmuAction(name + ".BRANCH_1");
      builder.registerAction(BRANCH_1);
      builder.registerTransition(new MmuTransition(ASSIGN_1, BRANCH_1, new MmuGuard(Nodes.and(Nodes.noteq(pte.r, NodeValue.newBitVector(0x1, 1)), Nodes.noteq(pte.x, NodeValue.newBitVector(0x1, 1))))));
      this.ASSIGN_2 = new MmuAction(name + ".ASSIGN_2", new MmuBinding(va.i, NodeValue.newInteger(2)));
      builder.registerAction(ASSIGN_2);
      builder.registerTransition(new MmuTransition(BRANCH_1, ASSIGN_2));
      final PT48.Entry TMP_1 = new PT48.Entry(name + ".TMP_1");
      SV48TranslateCycle.Function call_1 = SV48TranslateCycle.get().newCall(builder, TMP_1, va);
      builder.registerTransition(new MmuTransition(ASSIGN_2, call_1.START));
      this.ASSIGN_3 = new MmuAction(name + ".ASSIGN_3", pte, TMP_1);
      builder.registerAction(ASSIGN_3);
      builder.registerTransition(new MmuTransition(call_1.STOP, ASSIGN_3));
      this.BRANCH_2 = new MmuAction(name + ".BRANCH_2");
      builder.registerAction(BRANCH_2);
      builder.registerTransition(new MmuTransition(ASSIGN_3, BRANCH_2, new MmuGuard(Nodes.or(Nodes.eq(pte.r, NodeValue.newBitVector(0x1, 1)), Nodes.eq(pte.x, NodeValue.newBitVector(0x1, 1))))));
      this.JOIN_1 = new MmuAction(name + ".JOIN_1");
      builder.registerAction(JOIN_1);
      builder.registerTransition(new MmuTransition(BRANCH_2, JOIN_1));
      this.BRANCH_3 = new MmuAction(name + ".BRANCH_3");
      builder.registerAction(BRANCH_3);
      builder.registerTransition(new MmuTransition(ASSIGN_3, BRANCH_3, new MmuGuard(Nodes.and(Nodes.noteq(pte.r, NodeValue.newBitVector(0x1, 1)), Nodes.noteq(pte.x, NodeValue.newBitVector(0x1, 1))))));
      this.ASSIGN_4 = new MmuAction(name + ".ASSIGN_4", new MmuBinding(va.i, NodeValue.newInteger(1)));
      builder.registerAction(ASSIGN_4);
      builder.registerTransition(new MmuTransition(BRANCH_3, ASSIGN_4));
      final PT48.Entry TMP_2 = new PT48.Entry(name + ".TMP_2");
      SV48TranslateCycle.Function call_2 = SV48TranslateCycle.get().newCall(builder, TMP_2, va);
      builder.registerTransition(new MmuTransition(ASSIGN_4, call_2.START));
      this.ASSIGN_5 = new MmuAction(name + ".ASSIGN_5", pte, TMP_2);
      builder.registerAction(ASSIGN_5);
      builder.registerTransition(new MmuTransition(call_2.STOP, ASSIGN_5));
      this.BRANCH_4 = new MmuAction(name + ".BRANCH_4");
      builder.registerAction(BRANCH_4);
      builder.registerTransition(new MmuTransition(ASSIGN_5, BRANCH_4, new MmuGuard(Nodes.or(Nodes.eq(pte.r, NodeValue.newBitVector(0x1, 1)), Nodes.eq(pte.x, NodeValue.newBitVector(0x1, 1))))));
      this.JOIN_2 = new MmuAction(name + ".JOIN_2");
      builder.registerAction(JOIN_2);
      builder.registerTransition(new MmuTransition(BRANCH_4, JOIN_2));
      this.BRANCH_5 = new MmuAction(name + ".BRANCH_5");
      builder.registerAction(BRANCH_5);
      builder.registerTransition(new MmuTransition(ASSIGN_5, BRANCH_5, new MmuGuard(Nodes.and(Nodes.noteq(pte.r, NodeValue.newBitVector(0x1, 1)), Nodes.noteq(pte.x, NodeValue.newBitVector(0x1, 1))))));
      this.ASSIGN_6 = new MmuAction(name + ".ASSIGN_6", new MmuBinding(va.i, NodeValue.newInteger(0)));
      builder.registerAction(ASSIGN_6);
      builder.registerTransition(new MmuTransition(BRANCH_5, ASSIGN_6));
      final PT48.Entry TMP_3 = new PT48.Entry(name + ".TMP_3");
      SV48TranslateCycle.Function call_3 = SV48TranslateCycle.get().newCall(builder, TMP_3, va);
      builder.registerTransition(new MmuTransition(ASSIGN_6, call_3.START));
      this.ASSIGN_7 = new MmuAction(name + ".ASSIGN_7", pte, TMP_3);
      builder.registerAction(ASSIGN_7);
      builder.registerTransition(new MmuTransition(call_3.STOP, ASSIGN_7));
      this.BRANCH_6 = new MmuAction(name + ".BRANCH_6");
      builder.registerAction(BRANCH_6);
      builder.registerTransition(new MmuTransition(ASSIGN_7, BRANCH_6, new MmuGuard(Nodes.or(Nodes.eq(pte.r, NodeValue.newBitVector(0x1, 1)), Nodes.eq(pte.x, NodeValue.newBitVector(0x1, 1))))));
      this.JOIN_3 = new MmuAction(name + ".JOIN_3");
      builder.registerAction(JOIN_3);
      builder.registerTransition(new MmuTransition(BRANCH_6, JOIN_3));
      this.BRANCH_7 = new MmuAction(name + ".BRANCH_7");
      builder.registerAction(BRANCH_7);
      builder.registerTransition(new MmuTransition(ASSIGN_7, BRANCH_7, new MmuGuard(Nodes.and(Nodes.noteq(pte.r, NodeValue.newBitVector(0x1, 1)), Nodes.noteq(pte.x, NodeValue.newBitVector(0x1, 1))))));
      this.page_fault_exception = new MmuAction(name + ".page_fault_exception", true);
      builder.registerAction(page_fault_exception);
      builder.registerTransition(new MmuTransition(BRANCH_7, page_fault_exception));
      builder.registerTransition(new MmuTransition(JOIN_3, JOIN_2));
      builder.registerTransition(new MmuTransition(JOIN_2, JOIN_1));
      builder.registerTransition(new MmuTransition(JOIN_1, JOIN_0));
      this.BRANCH_8 = new MmuAction(name + ".BRANCH_8");
      builder.registerAction(BRANCH_8);
      builder.registerTransition(new MmuTransition(JOIN_0, BRANCH_8, new MmuGuard(Nodes.and(Nodes.eq(va.i, NodeValue.newBitVector(0x3, 2)), Nodes.noteq(Nodes.bvconcat(pte.ppn2, Nodes.bvconcat(pte.ppn1, pte.ppn0)), NodeValue.newBitVector(0x0, 27))))));
      builder.registerTransition(new MmuTransition(BRANCH_8, page_fault_exception));
      this.BRANCH_9 = new MmuAction(name + ".BRANCH_9");
      builder.registerAction(BRANCH_9);
      builder.registerTransition(new MmuTransition(JOIN_0, BRANCH_9, new MmuGuard(Nodes.or(Nodes.noteq(va.i, NodeValue.newBitVector(0x3, 2)), Nodes.eq(Nodes.bvconcat(pte.ppn2, Nodes.bvconcat(pte.ppn1, pte.ppn0)), NodeValue.newBitVector(0x0, 27))))));
      this.BRANCH_10 = new MmuAction(name + ".BRANCH_10");
      builder.registerAction(BRANCH_10);
      builder.registerTransition(new MmuTransition(BRANCH_9, BRANCH_10, new MmuGuard(Nodes.and(Nodes.eq(va.i, NodeValue.newBitVector(0x2, 2)), Nodes.noteq(Nodes.bvconcat(pte.ppn1, pte.ppn0), NodeValue.newBitVector(0x0, 18))))));
      builder.registerTransition(new MmuTransition(BRANCH_10, page_fault_exception));
      this.BRANCH_11 = new MmuAction(name + ".BRANCH_11");
      builder.registerAction(BRANCH_11);
      builder.registerTransition(new MmuTransition(BRANCH_9, BRANCH_11, new MmuGuard(Nodes.or(Nodes.noteq(va.i, NodeValue.newBitVector(0x2, 2)), Nodes.eq(Nodes.bvconcat(pte.ppn1, pte.ppn0), NodeValue.newBitVector(0x0, 18))))));
      this.BRANCH_12 = new MmuAction(name + ".BRANCH_12");
      builder.registerAction(BRANCH_12);
      builder.registerTransition(new MmuTransition(BRANCH_11, BRANCH_12, new MmuGuard(Nodes.and(Nodes.eq(va.i, NodeValue.newBitVector(0x1, 2)), Nodes.noteq(pte.ppn0, NodeValue.newBitVector(0x0, 9))))));
      builder.registerTransition(new MmuTransition(BRANCH_12, page_fault_exception));
      this.BRANCH_13 = new MmuAction(name + ".BRANCH_13");
      builder.registerAction(BRANCH_13);
      builder.registerTransition(new MmuTransition(BRANCH_11, BRANCH_13, new MmuGuard(Nodes.or(Nodes.noteq(va.i, NodeValue.newBitVector(0x1, 2)), Nodes.eq(pte.ppn0, NodeValue.newBitVector(0x0, 9))))));
      this.BRANCH_14 = new MmuAction(name + ".BRANCH_14");
      builder.registerAction(BRANCH_14);
      builder.registerTransition(new MmuTransition(BRANCH_13, BRANCH_14, new MmuGuard(Nodes.eq(pte.a, NodeValue.newBitVector(0x0, 1)))));
      builder.registerTransition(new MmuTransition(BRANCH_14, page_fault_exception));
      this.BRANCH_15 = new MmuAction(name + ".BRANCH_15");
      builder.registerAction(BRANCH_15);
      builder.registerTransition(new MmuTransition(BRANCH_13, BRANCH_15, new MmuGuard(Nodes.noteq(pte.a, NodeValue.newBitVector(0x0, 1)))));
      this.BRANCH_16 = new MmuAction(name + ".BRANCH_16");
      builder.registerAction(BRANCH_16);
      builder.registerTransition(new MmuTransition(BRANCH_15, BRANCH_16, new MmuGuard(Nodes.and(Nodes.eq(va.type, NodeValue.newBitVector(0x1, 1)), Nodes.eq(pte.d, NodeValue.newBitVector(0x0, 1))))));
      builder.registerTransition(new MmuTransition(BRANCH_16, page_fault_exception));
      this.BRANCH_17 = new MmuAction(name + ".BRANCH_17");
      builder.registerAction(BRANCH_17);
      builder.registerTransition(new MmuTransition(BRANCH_15, BRANCH_17, new MmuGuard(Nodes.or(Nodes.noteq(va.type, NodeValue.newBitVector(0x1, 1)), Nodes.noteq(pte.d, NodeValue.newBitVector(0x0, 1))))));
      this.ASSIGN_8 = new MmuAction(name + ".ASSIGN_8", new MmuBinding(Nodes.bvextract(11, 0, pa.value), Nodes.bvextract(11, 0, va.value)));
      builder.registerAction(ASSIGN_8);
      builder.registerTransition(new MmuTransition(BRANCH_17, ASSIGN_8));
      this.ASSIGN_9 = new MmuAction(name + ".ASSIGN_9", new MmuBinding(Nodes.bvextract(55, 39, pa.value), pte.ppn3));
      builder.registerAction(ASSIGN_9);
      builder.registerTransition(new MmuTransition(ASSIGN_8, ASSIGN_9));
      this.ASSIGN_10 = new MmuAction(name + ".ASSIGN_10", new MmuBinding(Nodes.bvextract(38, 30, pa.value), pte.ppn2));
      builder.registerAction(ASSIGN_10);
      builder.registerTransition(new MmuTransition(ASSIGN_9, ASSIGN_10));
      this.ASSIGN_11 = new MmuAction(name + ".ASSIGN_11", new MmuBinding(Nodes.bvextract(29, 21, pa.value), pte.ppn1));
      builder.registerAction(ASSIGN_11);
      builder.registerTransition(new MmuTransition(ASSIGN_10, ASSIGN_11));
      this.ASSIGN_12 = new MmuAction(name + ".ASSIGN_12", new MmuBinding(Nodes.bvextract(20, 12, pa.value), pte.ppn0));
      builder.registerAction(ASSIGN_12);
      builder.registerTransition(new MmuTransition(ASSIGN_11, ASSIGN_12));
      this.BRANCH_18 = new MmuAction(name + ".BRANCH_18");
      builder.registerAction(BRANCH_18);
      builder.registerTransition(new MmuTransition(ASSIGN_12, BRANCH_18, new MmuGuard(Nodes.eq(va.i, NodeValue.newBitVector(0x3, 2)))));
      this.ASSIGN_13 = new MmuAction(name + ".ASSIGN_13", new MmuBinding(Nodes.bvextract(38, 12, pa.value), Nodes.bvextract(38, 12, va.value)));
      builder.registerAction(ASSIGN_13);
      builder.registerTransition(new MmuTransition(BRANCH_18, ASSIGN_13));
      this.JOIN_4 = new MmuAction(name + ".JOIN_4");
      builder.registerAction(JOIN_4);
      builder.registerTransition(new MmuTransition(ASSIGN_13, JOIN_4));
      this.BRANCH_19 = new MmuAction(name + ".BRANCH_19");
      builder.registerAction(BRANCH_19);
      builder.registerTransition(new MmuTransition(ASSIGN_12, BRANCH_19, new MmuGuard(Nodes.eq(va.i, NodeValue.newBitVector(0x2, 2)))));
      this.ASSIGN_14 = new MmuAction(name + ".ASSIGN_14", new MmuBinding(Nodes.bvextract(29, 12, pa.value), Nodes.bvextract(29, 12, va.value)));
      builder.registerAction(ASSIGN_14);
      builder.registerTransition(new MmuTransition(BRANCH_19, ASSIGN_14));
      builder.registerTransition(new MmuTransition(ASSIGN_14, JOIN_4));
      this.BRANCH_20 = new MmuAction(name + ".BRANCH_20");
      builder.registerAction(BRANCH_20);
      builder.registerTransition(new MmuTransition(ASSIGN_12, BRANCH_20, new MmuGuard(Nodes.eq(va.i, NodeValue.newBitVector(0x1, 2)))));
      this.ASSIGN_15 = new MmuAction(name + ".ASSIGN_15", new MmuBinding(Nodes.bvextract(20, 12, pa.value), Nodes.bvextract(20, 12, va.value)));
      builder.registerAction(ASSIGN_15);
      builder.registerTransition(new MmuTransition(BRANCH_20, ASSIGN_15));
      builder.registerTransition(new MmuTransition(ASSIGN_15, JOIN_4));
      this.BRANCH_21 = new MmuAction(name + ".BRANCH_21");
      builder.registerAction(BRANCH_21);
      builder.registerTransition(new MmuTransition(ASSIGN_12, BRANCH_21, new MmuGuard(Nodes.and(Nodes.noteq(va.i, NodeValue.newBitVector(0x3, 2)), Nodes.noteq(va.i, NodeValue.newBitVector(0x2, 2)), Nodes.noteq(va.i, NodeValue.newBitVector(0x1, 2))))));
      builder.registerTransition(new MmuTransition(BRANCH_21, JOIN_4));
      this.ASSIGN_16 = new MmuAction(name + ".ASSIGN_16", SV48Translate, pa);
      builder.registerAction(ASSIGN_16);
      builder.registerTransition(new MmuTransition(JOIN_4, ASSIGN_16));
      builder.registerTransition(new MmuTransition(ASSIGN_16, STOP));
    }
  }
}
