/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mmu.spec;

import ru.ispras.fortress.data.Data;
import ru.ispras.fortress.data.DataType;
import ru.ispras.fortress.data.Variable;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.fortress.expression.Nodes;
import ru.ispras.fortress.expression.NodeValue;
import ru.ispras.fortress.expression.NodeVariable;
import ru.ispras.microtesk.mmu.basis.MemoryOperation;
import ru.ispras.microtesk.mmu.model.spec.MmuSubsystem;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.mmu.basis.BufferAccessEvent;
import ru.ispras.microtesk.mmu.model.spec.MmuAction;
import ru.ispras.microtesk.mmu.model.spec.MmuBinding;
import ru.ispras.microtesk.mmu.model.spec.MmuBufferAccess;
import ru.ispras.microtesk.mmu.model.spec.MmuGuard;
import ru.ispras.microtesk.mmu.model.spec.MmuSegment;
import ru.ispras.microtesk.mmu.model.spec.MmuTransition;

/**
 * The {@code memory} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class memory {
  public final VA va = VA.get();
  private final PA pa = PA.get();

  public final NodeVariable data;

  public final MmuAction START;
  public final MmuAction STOP;

  private final MmuAction IF_READ;
  private final MmuAction ASSIGN_0;
  private final MmuAction ASSIGN_1;

  private final MmuAction IF_WRITE;
  private final MmuAction ASSIGN_2;
  private final MmuAction ASSIGN_3;

  protected memory(final MmuSubsystem.Builder builder) {
    this(builder, "memory");
  }

  private memory(final MmuSubsystem.Builder builder, final String name) {
    builder.setName("memory");

    this.data = new NodeVariable(name + ".data", DataType.bitVector(64));
    builder.setDataVariable(data);


    this.START = new MmuAction(name + ".START");
    builder.registerAction(START);
    this.STOP = new MmuAction(name + ".STOP");
    builder.registerAction(STOP);

    this.IF_READ = new MmuAction(name + ".IF_READ");
    builder.registerAction(IF_READ);
    builder.registerTransition(new MmuTransition(START, IF_READ, new MmuGuard(MemoryOperation.LOAD)));
    final PA TMP_0 = new PA(name + ".TMP_0");
    PreTranslateAddress.Function call_0 = PreTranslateAddress.get().newCall(builder, TMP_0, va);
    builder.registerTransition(new MmuTransition(IF_READ, call_0.START));
    this.ASSIGN_0 = new MmuAction(name + ".ASSIGN_0", pa, TMP_0);
    builder.registerAction(ASSIGN_0);
    builder.registerTransition(new MmuTransition(call_0.STOP, ASSIGN_0));
    this.ASSIGN_1 = new MmuAction(name + ".ASSIGN_1", new MmuBufferAccess(MEM.get(), BufferAccessEvent.READ, MEM.get().getAddress(), MEM.get(), pa), new MmuBinding(data, MEM.get().DATA));
    builder.registerAction(ASSIGN_1);
    builder.registerTransition(new MmuTransition(ASSIGN_0, ASSIGN_1));
    builder.registerTransition(new MmuTransition(ASSIGN_1, STOP));

    this.IF_WRITE = new MmuAction(name + ".IF_WRITE");
    builder.registerAction(IF_WRITE);
    builder.registerTransition(new MmuTransition(START, IF_WRITE, new MmuGuard(MemoryOperation.STORE)));
    final PA TMP_1 = new PA(name + ".TMP_1");
    PreTranslateAddress.Function call_1 = PreTranslateAddress.get().newCall(builder, TMP_1, va);
    builder.registerTransition(new MmuTransition(IF_WRITE, call_1.START));
    this.ASSIGN_2 = new MmuAction(name + ".ASSIGN_2", pa, TMP_1);
    builder.registerAction(ASSIGN_2);
    builder.registerTransition(new MmuTransition(call_1.STOP, ASSIGN_2));
    this.ASSIGN_3 = new MmuAction(name + ".ASSIGN_3", new MmuBufferAccess(MEM.get(), BufferAccessEvent.WRITE, MEM.get().getAddress(), MEM.get(), null), new MmuBinding(MEM.get().DATA, data));
    builder.registerAction(ASSIGN_3);
    builder.registerTransition(new MmuTransition(ASSIGN_2, ASSIGN_3));
    builder.registerTransition(new MmuTransition(ASSIGN_3, STOP));
  }
}
