/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class c_flwsp extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "c_flwsp",
          c_flwsp.class,
          null
          );
      addArgument("rd", F.INFO);
      addArgument("offset", Type.CARD(6));
      addShortcut(new Info_instruction16(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final F rd = (F) getArgument("rd", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new c_flwsp(rd, offset);
    }
  }
  private static final class Info_instruction16 extends IsaPrimitiveInfoAnd {
    Info_instruction16() {
      super(
          IsaPrimitiveKind.OP,
          "c_flwsp",
          instruction16.class,
          null
          );
      addArgument("rd", F.INFO);
      addArgument("offset", Type.CARD(6));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final F rd = (F) getArgument("rd", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new instruction16(
        new c_flwsp(
          rd,
          offset
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final F rd;
  public final Immediate offset;

  public c_flwsp(final F rd, final Immediate offset) {
    this.rd = rd;
    this.offset = offset;

    addArgument("rd", rd);
    addArgument("offset", offset);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("c.flwsp %s, %d(%s)", rd.text(vars__), offset.access().load().bigIntegerValue(), new X(new Immediate(Data.valueOf(Type.CARD(5), 0x2))).text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("011%1s%5s%3s%2s10", offset.access().bitField(3, 3).load().toString(), rd.image(vars__), offset.access().bitField(2, 0).load().toString(), offset.access().bitField(5, 4).load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    new flw(rd, new X(new Immediate(Data.valueOf(Type.CARD(5), 0x2))), new Immediate(Data.zeroExtend(Type.CARD(12), offset.access().load()).shiftLeft(Data.valueOf(Type.CARD(12), 0x2)))).execute(pe__, vars__);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}