/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class c_fsdsp extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "c_fsdsp",
          c_fsdsp.class,
          null
          );
      addArgument("rs2", F.INFO);
      addArgument("offset", Type.CARD(9));
      addShortcut(new Info_instruction16(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final F rs2 = (F) getArgument("rs2", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new c_fsdsp(rs2, offset);
    }
  }
  private static final class Info_instruction16 extends IsaPrimitiveInfoAnd {
    Info_instruction16() {
      super(
          IsaPrimitiveKind.OP,
          "c_fsdsp",
          instruction16.class,
          null
          );
      addArgument("rs2", F.INFO);
      addArgument("offset", Type.CARD(9));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final F rs2 = (F) getArgument("rs2", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new instruction16(
        new c_fsdsp(
          rs2,
          offset
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final F rs2;
  public final Immediate offset;

  public c_fsdsp(final F rs2, final Immediate offset) {
    this.rs2 = rs2;
    this.offset = offset;

    addArgument("rs2", rs2);
    addArgument("offset", offset);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    Execution.assertion(offset.access().bitField(2, 0).load().equals(Data.valueOf(Type.CARD(3), 0x0)), "C.FSDSP: offset<2..0> != 0");
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("c.fsdsp %s, %d(%s)", rs2.text(vars__), offset.access().load().bigIntegerValue(), new X(new Immediate(Data.valueOf(Type.CARD(5), 0x2))).text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("101%3s%3s%5s10", offset.access().bitField(5, 3).load().toString(), offset.access().bitField(8, 6).load().toString(), rs2.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new fsd(rs2, new X(new Immediate(Data.valueOf(Type.CARD(5), 0x2))), new Immediate(Data.zeroExtend(Type.CARD(12), offset.access().bitField(8, 3).load()).shiftLeft(Data.valueOf(Type.CARD(12), 0x3)))).execute(pe__, vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}