/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class c_srai extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "c_srai",
          c_srai.class,
          null
          );
      addArgument("rd", CX.INFO);
      addArgument("shamt", Type.CARD(6));
      addShortcut(new Info_instruction16(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final CX rd = (CX) getArgument("rd", args);
      final Immediate shamt = (Immediate) getArgument("shamt", args);

      return new c_srai(rd, shamt);
    }
  }
  private static final class Info_instruction16 extends IsaPrimitiveInfoAnd {
    Info_instruction16() {
      super(
          IsaPrimitiveKind.OP,
          "c_srai",
          instruction16.class,
          null
          );
      addArgument("rd", CX.INFO);
      addArgument("shamt", Type.CARD(6));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final CX rd = (CX) getArgument("rd", args);
      final Immediate shamt = (Immediate) getArgument("shamt", args);

      return new instruction16(
        new c_srai(
          rd,
          shamt
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final CX rd;
  public final Immediate shamt;

  public c_srai(final CX rd, final Immediate shamt) {
    this.rd = rd;
    this.shamt = shamt;

    addArgument("rd", rd);
    addArgument("shamt", shamt);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    Execution.assertion(!shamt.access().load().equals(Data.valueOf(Type.CARD(6), 0x0)), "C.SRAI(RV64C): shamt == 0");
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("c.srai %s, %d", rd.text(vars__), shamt.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("100%1s01%3s%5s01", shamt.access().bitField(5, 5).load().toString(), rd.image(vars__), shamt.access().bitField(4, 0).load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new srai(new X(new Immediate(Data.zeroExtend(Type.CARD(5), rd.i.access().load()).add(Data.valueOf(Type.CARD(5), 0x8)))), new X(new Immediate(Data.zeroExtend(Type.CARD(5), rd.i.access().load()).add(Data.valueOf(Type.CARD(5), 0x8)))), new Immediate(shamt.access())).execute(pe__, vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}