/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class exception extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "exception",
          exception.class,
          null
          );
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      return new exception();
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public exception() {
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.epc.access().store(pe__.PC.access().load());
    if (!pe__.DCSR_CAUSE.access().load().equals(Data.valueOf(Type.CARD(3), 0x0))) {
      if (pe__.t_cause.access().load().equals(Data.valueOf(CSR_TYPE, 0x3))) {
        pe__.PC.access().store(Data.valueOf(XWORD, 0x800));
      } else {
        pe__.PC.access().store(Data.valueOf(XWORD, 0x808));
      }
    } else {
      if (pe__.t_cause.access().load().equals(Data.valueOf(CSR_TYPE, 0x3)) && ((pe__.PRV.access().load().equals(Data.valueOf(Type.CARD(2), 0x3)) && pe__.DCSR_EBREAKM.access().load().equals(Data.valueOf(BIT, 0x1)) || pe__.PRV.access().load().equals(Data.valueOf(Type.CARD(2), 0x1)) && pe__.DCSR_EBREAKS.access().load().equals(Data.valueOf(BIT, 0x1))) || pe__.PRV.access().load().equals(Data.valueOf(Type.CARD(2), 0x0)) && pe__.DCSR_EBREAKU.access().load().equals(Data.valueOf(BIT, 0x1)))) {
        pe__.DCSR_CAUSE.access().store(Data.valueOf(Type.CARD(3), 0x1));
        pe__.DCSR_PRV.access().store(pe__.PRV.access().load());
        new set_privilege(new Immediate(Data.valueOf(Type.CARD(2), 0x3))).execute(pe__, vars__);
        pe__.DPC_CSR.access().store(pe__.PC.access().load());
        pe__.PC.access().store(Data.valueOf(XWORD, 0x800));
      } else {
        vars__.bit.access().store(pe__.t_cause.access().load());
        vars__.deleg.access().store(pe__.MEDELEG_CSR.access().load());
        if (!vars__.bit.access().load().and(Data.valueOf(CSR_TYPE, new BigInteger("8000000000000000", 16))).equals(Data.valueOf(CSR_TYPE, 0x0))) {
          vars__.interrupt.access().store(Data.valueOf(BIT, 0x1));
        } else {
          vars__.interrupt.access().store(Data.valueOf(BIT, 0x0));
        }
        if (vars__.interrupt.access().load().equals(Data.valueOf(BIT, 0x1))) {
          vars__.deleg.access().store(pe__.MEDELEG_CSR.access().load());
          vars__.bit.access().store(vars__.bit.access().load().and(Data.valueOf(CSR_TYPE, 0x7fffffffffffffffL)));
        }
        if ((pe__.PRV.access().load().compareTo(Data.valueOf(Type.CARD(2), 0x1)) <= 0) && (vars__.bit.access().load().compareTo(Data.valueOf(CSR_TYPE, 0x40)) < 0) && !vars__.deleg.access().load().shiftRight(vars__.bit.access().load()).and(Data.valueOf(Type.CARD(64), 0x1)).equals(Data.valueOf(CSR_TYPE, 0x0))) {
          pe__.PC.access().store(pe__.STVEC_CSR.access().load());
          pe__.SCAUSE_CSR.access().store(pe__.t_cause.access().load());
          pe__.SEPC_CSR.access().store(vars__.epc.access().load());
          pe__.STVAL_CSR.access().store(pe__.t_get_tval.access().load());
          pe__.MSTATUS_SPIE.access().store(pe__.MSTATUS_SIE.access().load());
          pe__.MSTATUS_SPP.access().store(Data.coerce(BIT, pe__.PRV.access(0).load()));
          pe__.MSTATUS_SIE.access().store(Data.valueOf(BIT, 0x0));
          new set_privilege(new Immediate(Data.valueOf(Type.CARD(2), 0x1))).execute(pe__, vars__);
        } else {
          if (pe__.MTVEC_CSR.access().load().and(Data.valueOf(CSR_TYPE, 0x1)).equals(Data.valueOf(CSR_TYPE, 0x1)) && vars__.interrupt.access().load().equals(Data.valueOf(BIT, 0x1))) {
            vars__.vector.access().store(Data.valueOf(CSR_TYPE, 0x4).multiply(vars__.bit.access().load()));
          } else {
            vars__.vector.access().store(Data.valueOf(CSR_TYPE, 0x0));
          }
          pe__.PC.access().store(pe__.MTVEC_CSR.access().load().and(Data.valueOf(CSR_TYPE, new BigInteger("ffffffffffffffff", 16))).add(vars__.vector.access().load()));
          pe__.MEPC_CSR.access().store(vars__.epc.access().load());
          pe__.MCAUSE_CSR.access().store(pe__.t_cause.access().load());
          pe__.MTVAL_CSR.access().store(pe__.t_get_tval.access().load());
          pe__.MSTATUS_MPIE.access().store(pe__.MSTATUS_MIE.access().load());
          pe__.MSTATUS_MPP.access().store(pe__.PRV.access().load());
          pe__.MSTATUS_MIE.access().store(Data.valueOf(BIT, 0x0));
          new set_privilege(new Immediate(Data.valueOf(Type.CARD(2), 0x3))).execute(pe__, vars__);
        }
      }
    }
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}