/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class fclass_d extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "fclass_d",
          fclass_d.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("rs1", F.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final F rs1 = (F) getArgument("rs1", args);

      return new fclass_d(rd, rs1);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "fclass_d",
          instruction.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("rs1", F.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final F rs1 = (F) getArgument("rs1", args);

      return new instruction(
        new fclass_d(
          rd,
          rs1
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rd;
  public final F rs1;

  public fclass_d(final X rd, final F rs1) {
    this.rd = rd;
    this.rs1 = rs1;

    addArgument("rd", rd);
    addArgument("rs1", rs1);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("fclass.d %s, %s", rd.text(vars__), rs1.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("1110001%5s%5s%3s%5s1010011", "00000", rs1.image(vars__), "001", rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.temp_fpd.access().store(Data.cast(FLOAT64, rs1.access(pe__, vars__).load()));
    vars__.sign_bit_d.access().store(rs1.access(pe__, vars__).bitField(63, 63).load());
    vars__.exponent_d.access().store(rs1.access(pe__, vars__).bitField(62, 52).load());
    vars__.precision_d.access().store(rs1.access(pe__, vars__).bitField(51, 0).load());
    rd.access(pe__, vars__).store(Data.valueOf(XWORD, 0x0));
    if (vars__.sign_bit_d.access().load().equals(Data.valueOf(BIT, 0x1)) && vars__.exponent_d.access().load().equals(Data.valueOf(Type.CARD(11), 0x7ff)) && vars__.precision_d.access().load().equals(Data.valueOf(Type.CARD(52), 0x0))) {
      rd.access(pe__, vars__).bitField(0, 0).store(Data.valueOf(Type.CARD(1), 0x1));
    } else if (vars__.sign_bit_d.access().load().equals(Data.valueOf(BIT, 0x1)) && vars__.exponent_d.access().load().equals(Data.valueOf(Type.CARD(11), 0x0)) && vars__.precision_d.access().load().equals(Data.valueOf(Type.CARD(52), 0x0))) {
      rd.access(pe__, vars__).bitField(3, 3).store(Data.valueOf(Type.CARD(1), 0x1));
    } else if (vars__.sign_bit_d.access().load().equals(Data.valueOf(BIT, 0x0)) && vars__.exponent_d.access().load().equals(Data.valueOf(Type.CARD(11), 0x0)) && vars__.precision_d.access().load().equals(Data.valueOf(Type.CARD(52), 0x0))) {
      rd.access(pe__, vars__).bitField(4, 4).store(Data.valueOf(Type.CARD(1), 0x1));
    } else if (vars__.sign_bit_d.access().load().equals(Data.valueOf(BIT, 0x0)) && vars__.exponent_d.access().load().equals(Data.valueOf(Type.CARD(11), 0x7ff)) && vars__.precision_d.access().load().equals(Data.valueOf(Type.CARD(52), 0x0))) {
      rd.access(pe__, vars__).bitField(7, 7).store(Data.valueOf(Type.CARD(1), 0x1));
    } else if (vars__.temp_fpd.access().load().isSignalingNan()) {
      rd.access(pe__, vars__).bitField(8, 8).store(Data.valueOf(Type.CARD(1), 0x1));
    } else if (vars__.temp_fpd.access().load().isNan()) {
      rd.access(pe__, vars__).bitField(9, 9).store(Data.valueOf(Type.CARD(1), 0x1));
    } else if (vars__.sign_bit_d.access().load().equals(Data.valueOf(BIT, 0x0)) && vars__.exponent_d.access().load().equals(Data.valueOf(Type.CARD(11), 0x0))) {
      rd.access(pe__, vars__).bitField(5, 5).store(Data.valueOf(Type.CARD(1), 0x1));
    } else if (vars__.sign_bit_d.access().load().equals(Data.valueOf(BIT, 0x1)) && vars__.exponent_d.access().load().equals(Data.valueOf(Type.CARD(11), 0x0))) {
      rd.access(pe__, vars__).bitField(2, 2).store(Data.valueOf(Type.CARD(1), 0x1));
    } else if (vars__.sign_bit_d.access().load().equals(Data.valueOf(BIT, 0x1))) {
      rd.access(pe__, vars__).bitField(1, 1).store(Data.valueOf(Type.CARD(1), 0x1));
    } else if (vars__.sign_bit_d.access().load().equals(Data.valueOf(BIT, 0x0))) {
      rd.access(pe__, vars__).bitField(6, 6).store(Data.valueOf(Type.CARD(1), 0x1));
    } else {
      rd.access(pe__, vars__).store(Data.valueOf(XWORD, 0x0));
    }
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}