/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class fmax_s extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "fmax_s",
          fmax_s.class,
          null
          );
      addArgument("rd", F.INFO);
      addArgument("rs1", F.INFO);
      addArgument("rs2", F.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final F rd = (F) getArgument("rd", args);
      final F rs1 = (F) getArgument("rs1", args);
      final F rs2 = (F) getArgument("rs2", args);

      return new fmax_s(rd, rs1, rs2);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "fmax_s",
          instruction.class,
          null
          );
      addArgument("rd", F.INFO);
      addArgument("rs1", F.INFO);
      addArgument("rs2", F.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final F rd = (F) getArgument("rd", args);
      final F rs1 = (F) getArgument("rs1", args);
      final F rs2 = (F) getArgument("rs2", args);

      return new instruction(
        new fmax_s(
          rd,
          rs1,
          rs2
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final F rd;
  public final F rs1;
  public final F rs2;

  public fmax_s(final F rd, final F rs1, final F rs2) {
    this.rd = rd;
    this.rs1 = rs1;
    this.rs2 = rs2;

    addArgument("rd", rd);
    addArgument("rs1", rs1);
    addArgument("rs2", rs2);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("fmax.s %s, %s, %s", rd.text(vars__), rs1.text(vars__), rs2.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("0010100%5s%5s%3s%5s1010011", rs2.image(vars__), rs1.image(vars__), Data.valueOf(Type.CARD(3), 0x1).toString(), rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.tmp_ui3.access().store(Data.valueOf(Type.CARD(3), Execution.float_rounding_mode.load()));
    new setSFRoundingMode(new Immediate(Data.valueOf(Type.CARD(3), 0x1))).execute(pe__, vars__);
    vars__.temp_fps.access().store(Data.cast(FLOAT32, rs1.access(pe__, vars__).bitField(31, 0).load()));
    vars__.temp_fps2.access().store(Data.cast(FLOAT32, rs2.access(pe__, vars__).bitField(31, 0).load()));
    rd.access(pe__, vars__).store(Data.valueOf(Type.CARD(64), new BigInteger("ffffffffffffffff", 16)));
    Execution.float_exception_flags.store(0);
    if ((vars__.temp_fps2.access().load().compareTo(vars__.temp_fps.access().load()) < 0)) {
      rd.access(pe__, vars__).bitField(31, 0).store(vars__.temp_fps.access().bitField(31, 0).load());
    } else {
      rd.access(pe__, vars__).bitField(31, 0).store(vars__.temp_fps2.access().bitField(31, 0).load());
    }
    Execution.float_rounding_mode.store(vars__.tmp_ui3.access().load());
    new process_float_exception_flags().execute(pe__, vars__);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}