/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class fmul_d extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "fmul_d",
          fmul_d.class,
          null
          );
      addArgument("rd", F.INFO);
      addArgument("rs1", F.INFO);
      addArgument("rs2", F.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final F rd = (F) getArgument("rd", args);
      final F rs1 = (F) getArgument("rs1", args);
      final F rs2 = (F) getArgument("rs2", args);

      return new fmul_d(rd, rs1, rs2);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "fmul_d",
          instruction.class,
          null
          );
      addArgument("rd", F.INFO);
      addArgument("rs1", F.INFO);
      addArgument("rs2", F.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final F rd = (F) getArgument("rd", args);
      final F rs1 = (F) getArgument("rs1", args);
      final F rs2 = (F) getArgument("rs2", args);

      return new instruction(
        new fmul_d(
          rd,
          rs1,
          rs2
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final F rd;
  public final F rs1;
  public final F rs2;

  public fmul_d(final F rd, final F rs1, final F rs2) {
    this.rd = rd;
    this.rs1 = rs1;
    this.rs2 = rs2;

    addArgument("rd", rd);
    addArgument("rs1", rs1);
    addArgument("rs2", rs2);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("fmul.d %s, %s, %s", rd.text(vars__), rs1.text(vars__), rs2.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("0001001%s%s%3s%s1010011", rs2.image(vars__), rs1.image(vars__), Data.valueOf(Type.CARD(3), 0x0).toString(), rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.temp_fpd.access().store(Data.cast(FLOAT64, rs1.access(pe__, vars__).bitField(63, 0).load()).multiply(Data.cast(FLOAT64, rs2.access(pe__, vars__).bitField(63, 0).load())));
    rd.access(pe__, vars__).store(Data.valueOf(Type.CARD(64), 0x0));
    rd.access(pe__, vars__).bitField(63, 0).store(vars__.temp_fpd.access().bitField(63, 0).load());
    new process_float_exception_flags().execute(pe__, vars__);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}