/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class jal extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "jal",
          jal.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("imm", JUMP_ADDR_JAL.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final IsaPrimitive imm = (IsaPrimitive) getArgument("imm", args);

      return new jal(rd, imm);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "jal",
          instruction.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("imm", JUMP_ADDR_JAL.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final IsaPrimitive imm = (IsaPrimitive) getArgument("imm", args);

      return new instruction(
        new jal(
          rd,
          imm
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rd;
  public final IsaPrimitive imm;

  public jal(final X rd, final IsaPrimitive imm) {
    this.rd = rd;
    this.imm = imm;

    addArgument("rd", rd);
    addArgument("imm", imm);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("jal %s, %s", rd.text(vars__), imm.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%20s%5s1101111", imm.image(vars__), rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    rd.access(pe__, vars__).store(pe__.PC.access().load().add(Data.valueOf(XWORD, 0x4)));
    pe__.PC.access().store(pe__.PC.access().load().add(Data.signExtend(XWORD, imm.access(pe__, vars__).load()).shiftLeft(Data.valueOf(XWORD, 0x1))));
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}