/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class load_global extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "load_global",
          load_global.class,
          null
          );
      addArgument("tmp_address_op", XWORD);
      addArgument("load_type", Type.CARD(4));
      addArgument("sign_type", BIT);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate tmp_address_op = (Immediate) getArgument("tmp_address_op", args);
      final Immediate load_type = (Immediate) getArgument("load_type", args);
      final Immediate sign_type = (Immediate) getArgument("sign_type", args);

      return new load_global(tmp_address_op, load_type, sign_type);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate tmp_address_op;
  public final Immediate load_type;
  public final Immediate sign_type;

  public load_global(final Immediate tmp_address_op, final Immediate load_type, final Immediate sign_type) {
    this.tmp_address_op = tmp_address_op;
    this.load_type = load_type;
    this.sign_type = sign_type;

    addArgument("tmp_address_op", tmp_address_op);
    addArgument("load_type", load_type);
    addArgument("sign_type", sign_type);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.mem_index.access().store(Data.coerce(Type.CARD(53), tmp_address_op.access().load().shiftRight(Data.valueOf(XWORD, 0x3))));
    if (load_type.access().load().equals(Data.valueOf(Type.CARD(4), 0x1))) {
      vars__.tmp_bit_offset.access().store(Data.zeroExtend(Type.CARD(6), tmp_address_op.access().bitField(2, 0).load()).multiply(Data.valueOf(Type.CARD(6), 0x8)));
      vars__.tmp_byte.access().store(pe__.MEM.access(vars__.mem_index.access().load()).bitField(vars__.tmp_bit_offset.access().load().add(Data.valueOf(Type.CARD(6), 0x7)), vars__.tmp_bit_offset.access().load()).load());
      if (sign_type.access().load().equals(Data.valueOf(BIT, 0x0))) {
        vars__.rd_var.access().store(Data.zeroExtend(XWORD, vars__.tmp_byte.access().load()));
      } else {
        vars__.rd_var.access().store(Data.signExtend(XWORD, vars__.tmp_byte.access().load()));
      }
    } else if (load_type.access().load().equals(Data.valueOf(Type.CARD(4), 0x2))) {
      if (!tmp_address_op.access().bitField(2, 0).load().equals(Data.valueOf(Type.CARD(3), 0x7))) {
        vars__.tmp_bit_offset.access().store(Data.zeroExtend(Type.CARD(6), tmp_address_op.access().bitField(2, 0).load()).multiply(Data.valueOf(Type.CARD(6), 0x8)));
        vars__.tmp_half.access().store(pe__.MEM.access(vars__.mem_index.access().load()).bitField(vars__.tmp_bit_offset.access().load().add(Data.valueOf(Type.CARD(6), 0xf)), vars__.tmp_bit_offset.access().load()).load());
      } else {
        vars__.tmp_half.access().store(Location.concat(pe__.MEM.access(vars__.mem_index.access().load().add(Data.valueOf(Type.CARD(53), 0x1))).bitField(7, 0), pe__.MEM.access(vars__.mem_index.access().load()).bitField(63, 56)));
      }
      if (sign_type.access().load().equals(Data.valueOf(BIT, 0x0))) {
        vars__.rd_var.access().store(Data.zeroExtend(XWORD, vars__.tmp_half.access().load()));
      } else {
        vars__.rd_var.access().store(Data.signExtend(XWORD, vars__.tmp_half.access().load()));
      }
    } else if (load_type.access().load().equals(Data.valueOf(Type.CARD(4), 0x4))) {
      vars__.tmp_bit_offset.access().store(Data.zeroExtend(Type.CARD(6), tmp_address_op.access().bitField(2, 0).load()).multiply(Data.valueOf(Type.CARD(6), 0x8)));
      if ((tmp_address_op.access().bitField(2, 0).load().compareTo(Data.valueOf(Type.CARD(3), 0x5)) < 0)) {
        vars__.tmp_word.access().store(pe__.MEM.access(vars__.mem_index.access().load()).bitField(vars__.tmp_bit_offset.access().load().add(Data.valueOf(Type.CARD(6), 0x1f)), vars__.tmp_bit_offset.access().load()).load());
      } else {
        vars__.tmp_dword1.access().store(pe__.MEM.access(vars__.mem_index.access().load().add(Data.valueOf(Type.CARD(53), 0x1))).load());
        vars__.tmp_dword2.access().store(pe__.MEM.access(vars__.mem_index.access().load()).load());
        if (tmp_address_op.access().bitField(1, 0).load().equals(Data.valueOf(Type.CARD(2), 0x1))) {
          vars__.tmp_word.access().store(Location.concat(vars__.tmp_dword1.access().bitField(7, 0), vars__.tmp_dword2.access().bitField(63, 40)));
        } else if (tmp_address_op.access().bitField(1, 0).load().equals(Data.valueOf(Type.CARD(2), 0x2))) {
          vars__.tmp_word.access().store(Location.concat(vars__.tmp_dword1.access().bitField(15, 0), vars__.tmp_dword2.access().bitField(63, 48)));
        } else {
          vars__.tmp_word.access().store(Location.concat(vars__.tmp_dword1.access().bitField(23, 0), vars__.tmp_dword2.access().bitField(63, 56)));
        }
      }
      if (sign_type.access().load().equals(Data.valueOf(BIT, 0x0))) {
        vars__.rd_var.access().store(Data.zeroExtend(XWORD, vars__.tmp_word.access().load()));
      } else {
        vars__.rd_var.access().store(Data.signExtend(XWORD, vars__.tmp_word.access().load()));
      }
    } else if (load_type.access().load().equals(Data.valueOf(Type.CARD(4), 0x8))) {
      if (tmp_address_op.access().bitField(2, 0).load().equals(Data.valueOf(Type.CARD(3), 0x0))) {
        vars__.tmp_dword.access().store(pe__.MEM.access(vars__.mem_index.access().load()).load());
      } else {
        vars__.tmp_dword1.access().store(pe__.MEM.access(vars__.mem_index.access().load().add(Data.valueOf(Type.CARD(53), 0x1))).load());
        vars__.tmp_dword2.access().store(pe__.MEM.access(vars__.mem_index.access().load()).load());
        if (tmp_address_op.access().bitField(2, 0).load().equals(Data.valueOf(Type.CARD(3), 0x1))) {
          vars__.tmp_dword.access().store(Location.concat(vars__.tmp_dword1.access().bitField(7, 0), vars__.tmp_dword2.access().bitField(63, 8)));
        } else if (tmp_address_op.access().bitField(2, 0).load().equals(Data.valueOf(Type.CARD(3), 0x2))) {
          vars__.tmp_dword.access().store(Location.concat(vars__.tmp_dword1.access().bitField(15, 0), vars__.tmp_dword2.access().bitField(63, 16)));
        } else if (tmp_address_op.access().bitField(2, 0).load().equals(Data.valueOf(Type.CARD(3), 0x3))) {
          vars__.tmp_dword.access().store(Location.concat(vars__.tmp_dword1.access().bitField(23, 0), vars__.tmp_dword2.access().bitField(63, 24)));
        } else if (tmp_address_op.access().bitField(2, 0).load().equals(Data.valueOf(Type.CARD(3), 0x4))) {
          vars__.tmp_dword.access().store(Location.concat(vars__.tmp_dword1.access().bitField(31, 0), vars__.tmp_dword2.access().bitField(63, 32)));
        } else if (tmp_address_op.access().bitField(2, 0).load().equals(Data.valueOf(Type.CARD(3), 0x5))) {
          vars__.tmp_dword.access().store(Location.concat(vars__.tmp_dword1.access().bitField(39, 0), vars__.tmp_dword2.access().bitField(63, 40)));
        } else if (tmp_address_op.access().bitField(2, 0).load().equals(Data.valueOf(Type.CARD(3), 0x6))) {
          vars__.tmp_dword.access().store(Location.concat(vars__.tmp_dword1.access().bitField(47, 0), vars__.tmp_dword2.access().bitField(63, 48)));
        } else {
          vars__.tmp_dword.access().store(Location.concat(vars__.tmp_dword1.access().bitField(55, 0), vars__.tmp_dword2.access().bitField(63, 56)));
        }
      }
      vars__.rd_var.access().store(vars__.tmp_dword.access().load());
    }
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}