/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.memory.Location;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class load_rvi extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "load_rvi",
          load_rvi.class,
          null
          );
      addArgument("tmp_address_op", XWORD);
      addArgument("rd", X.INFO);
      addArgument("load_type", Type.CARD(4));
      addArgument("sign_type", BIT);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate tmp_address_op = (Immediate) getArgument("tmp_address_op", args);
      final X rd = (X) getArgument("rd", args);
      final Immediate load_type = (Immediate) getArgument("load_type", args);
      final Immediate sign_type = (Immediate) getArgument("sign_type", args);

      return new load_rvi(tmp_address_op, rd, load_type, sign_type);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate tmp_address_op;
  public final X rd;
  public final Immediate load_type;
  public final Immediate sign_type;

  public load_rvi(final Immediate tmp_address_op, final X rd, final Immediate load_type, final Immediate sign_type) {
    this.tmp_address_op = tmp_address_op;
    this.rd = rd;
    this.load_type = load_type;
    this.sign_type = sign_type;

    addArgument("tmp_address_op", tmp_address_op);
    addArgument("rd", rd);
    addArgument("load_type", load_type);
    addArgument("sign_type", sign_type);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    new load_global(tmp_address_op, load_type, sign_type).execute(pe__, vars__);
    rd.access(pe__, vars__).store(vars__.rd_var.access().load());
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}