/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class sd extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "sd",
          sd.class,
          null
          );
      addArgument("rs2", X.INFO);
      addArgument("rs1", X.INFO);
      addArgument("imm", Type.CARD(12));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rs2 = (X) getArgument("rs2", args);
      final X rs1 = (X) getArgument("rs1", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new sd(rs2, rs1, imm);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "sd",
          instruction.class,
          null
          );
      addArgument("rs2", X.INFO);
      addArgument("rs1", X.INFO);
      addArgument("imm", Type.CARD(12));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rs2 = (X) getArgument("rs2", args);
      final X rs1 = (X) getArgument("rs1", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new instruction(
        new sd(
          rs2,
          rs1,
          imm
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rs2;
  public final X rs1;
  public final Immediate imm;

  public sd(final X rs2, final X rs1, final Immediate imm) {
    this.rs2 = rs2;
    this.rs1 = rs1;
    this.imm = imm;

    addArgument("rs2", rs2);
    addArgument("rs1", rs1);
    addArgument("imm", imm);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("sd %s, %s(%s)", rs2.text(vars__), new print_imm12(imm).text(vars__), rs1.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%7s%s%s011%5s0100011", imm.access().bitField(11, 5).load().toString(), rs2.image(vars__), rs1.image(vars__), imm.access().bitField(4, 0).load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.tmp_address.access().store(rs1.access(pe__, vars__).load().add(Data.signExtend(XWORD, imm.access().load())));
    new store_rvi(new Immediate(vars__.tmp_address.access()), rs2, new Immediate(Data.valueOf(Type.CARD(4), 0x8))).execute(pe__, vars__);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}