/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class set_privilege extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "set_privilege",
          set_privilege.class,
          null
          );
      addArgument("prv_op", Type.CARD(2));}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate prv_op = (Immediate) getArgument("prv_op", args);

      return new set_privilege(prv_op);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate prv_op;

  public set_privilege(final Immediate prv_op) {
    this.prv_op = prv_op;

    addArgument("prv_op", prv_op);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    Execution.assertion((prv_op.access().load().compareTo(Data.valueOf(Type.CARD(2), 0x3)) <= 0), "exception (set_privilege): prv_op > PRV_M");
    if (pe__.MISA_U.access().load().equals(Data.valueOf(BIT, 0x0))) {
      pe__.PRV.access().store(Data.valueOf(Type.CARD(2), 0x3));
    } else if ((prv_op.access().load().equals(Data.valueOf(Type.CARD(2), 0x2)) || pe__.MISA_S.access().load().equals(Data.valueOf(BIT, 0x0)))) {
      pe__.PRV.access().store(Data.valueOf(Type.CARD(2), 0x0));
    } else {
      pe__.PRV.access().store(prv_op.access().load());
    }
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}