/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class store_data extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "store_data",
          store_data.class,
          null
          );
      addArgument("op_type", Type.CARD(4));
      addArgument("address", XWORD);
      addArgument("store_value", XWORD);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate op_type = (Immediate) getArgument("op_type", args);
      final Immediate address = (Immediate) getArgument("address", args);
      final Immediate store_value = (Immediate) getArgument("store_value", args);

      return new store_data(op_type, address, store_value);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate op_type;
  public final Immediate address;
  public final Immediate store_value;

  public store_data(final Immediate op_type, final Immediate address, final Immediate store_value) {
    this.op_type = op_type;
    this.address = address;
    this.store_value = store_value;

    addArgument("op_type", op_type);
    addArgument("address", address);
    addArgument("store_value", store_value);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.tmp_bit.access().store(Data.valueOf(BIT, 0x0));
    new check_aligned(op_type, address).execute(pe__, vars__);
    vars__.mem_index.access().store(Data.coerce(Type.CARD(53), address.access().load().shiftRight(Data.valueOf(XWORD, 0x2))));
    if (!vars__.tmp_bit.access().load().equals(Data.valueOf(BIT, 0x1))) {
      new store_global(address, store_value, op_type).execute(pe__, vars__);
    }
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}