/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.memory.Location;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class store_rvi extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "store_rvi",
          store_rvi.class,
          null
          );
      addArgument("tmp_address_op", XWORD);
      addArgument("rs2", X.INFO);
      addArgument("store_type", Type.CARD(4));}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate tmp_address_op = (Immediate) getArgument("tmp_address_op", args);
      final X rs2 = (X) getArgument("rs2", args);
      final Immediate store_type = (Immediate) getArgument("store_type", args);

      return new store_rvi(tmp_address_op, rs2, store_type);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate tmp_address_op;
  public final X rs2;
  public final Immediate store_type;

  public store_rvi(final Immediate tmp_address_op, final X rs2, final Immediate store_type) {
    this.tmp_address_op = tmp_address_op;
    this.rs2 = rs2;
    this.store_type = store_type;

    addArgument("tmp_address_op", tmp_address_op);
    addArgument("rs2", rs2);
    addArgument("store_type", store_type);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.rs2_var.access().store(rs2.access(pe__, vars__).load());
    new store_global(tmp_address_op, new Immediate(vars__.rs2_var.access()), store_type).execute(pe__, vars__);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}