/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class tail extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "tail",
          tail.class,
          null
          );
      addArgument("delta", DELTA.INFO);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive delta = (IsaPrimitive) getArgument("delta", args);

      return new tail(delta);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final IsaPrimitive delta;

  public tail(final IsaPrimitive delta) {
    this.delta = delta;

    addArgument("delta", delta);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    delta.init(vars__);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("tail %s", delta.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%s%s", new auipc(new X(new Immediate(Data.valueOf(Type.CARD(5), 0x6))), new Immediate(vars__.tmp_delta.access().bitField(31, 12).load().add(Data.zeroExtend(Type.CARD(20), vars__.tmp_delta.access().bitField(11, 11).load())))).image(vars__), new jalr(new X(new Immediate(Data.valueOf(Type.CARD(5), 0x0))), new X(new Immediate(Data.valueOf(Type.CARD(5), 0x6))), new Immediate(vars__.tmp_delta.access().bitField(11, 0))).image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new instruction(new auipc(new X(new Immediate(Data.valueOf(Type.CARD(5), 0x6))), new Immediate(delta.access(pe__, vars__).bitField(31, 12).load().add(Data.zeroExtend(Type.CARD(20), delta.access(pe__, vars__).bitField(11, 11).load()))))).execute(pe__, vars__);
    new instruction(new jalr(new X(new Immediate(Data.valueOf(Type.CARD(5), 0x0))), new X(new Immediate(Data.valueOf(Type.CARD(5), 0x6))), new Immediate(delta.access(pe__, vars__).bitField(11, 0)))).execute(pe__, vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}