/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class vdiv extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "vdiv",
          vdiv.class,
          null
          );
      addArgument("vd", VR.INFO);
      addArgument("vs2", VR.INFO);
      addArgument("vs1", VR.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final VR vd = (VR) getArgument("vd", args);
      final VR vs2 = (VR) getArgument("vs2", args);
      final VR vs1 = (VR) getArgument("vs1", args);

      return new vdiv(vd, vs2, vs1);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "vdiv",
          instruction.class,
          null
          );
      addArgument("vd", VR.INFO);
      addArgument("vs2", VR.INFO);
      addArgument("vs1", VR.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final VR vd = (VR) getArgument("vd", args);
      final VR vs2 = (VR) getArgument("vs2", args);
      final VR vs1 = (VR) getArgument("vs1", args);

      return new instruction(
        new vdiv(
          vd,
          vs2,
          vs1
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final VR vd;
  public final VR vs2;
  public final VR vs1;

  public vdiv(final VR vd, final VR vs2, final VR vs1) {
    this.vd = vd;
    this.vs2 = vs2;
    this.vs1 = vs1;

    addArgument("vd", vd);
    addArgument("vs2", vs2);
    addArgument("vs1", vs1);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.v_funct6.access().store(Data.valueOf(Type.CARD(6), 0x21));
    vars__.v_funct3.access().store(Data.valueOf(Type.CARD(3), 0x2));
    vars__.v_vm.access().store(Data.valueOf(BIT, 0x1));
    Execution.assertion(vs1.i.access().load().mod(Data.valueOf(Type.CARD(5), 0x4)).equals(Data.valueOf(Type.CARD(5), 0x0)));
    Execution.assertion(vs2.i.access().load().mod(Data.valueOf(Type.CARD(5), 0x4)).equals(Data.valueOf(Type.CARD(5), 0x0)));
    Execution.assertion(vd.i.access().load().mod(Data.valueOf(Type.CARD(5), 0x4)).equals(Data.valueOf(Type.CARD(5), 0x0)));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("vdiv.vv %s, %s, %s", vd.text(vars__), vs2.text(vars__), vs1.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%6s%1s%5s%5s%3s%5s%7s", vars__.v_funct6.access().load().toString(), vars__.v_vm.access().load().toString(), vs2.image(vars__), vs1.image(vars__), vars__.v_funct3.access().load().toString(), vd.image(vars__), Data.valueOf(Type.CARD(7), 0x57).toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new vdiv_cycle_vv(new VR(new Immediate(vd.i.access())), new VR(new Immediate(vs2.i.access())), new VR(new Immediate(vs1.i.access()))).execute(pe__, vars__);
    new vdiv_cycle_vv(new VR(new Immediate(vd.i.access().load().add(Data.valueOf(Type.CARD(5), 0x1)))), new VR(new Immediate(vs2.i.access().load().add(Data.valueOf(Type.CARD(5), 0x1)))), new VR(new Immediate(vs1.i.access().load().add(Data.valueOf(Type.CARD(5), 0x1))))).execute(pe__, vars__);
    new vdiv_cycle_vv(new VR(new Immediate(vd.i.access().load().add(Data.valueOf(Type.CARD(5), 0x2)))), new VR(new Immediate(vs2.i.access().load().add(Data.valueOf(Type.CARD(5), 0x2)))), new VR(new Immediate(vs1.i.access().load().add(Data.valueOf(Type.CARD(5), 0x2))))).execute(pe__, vars__);
    new vdiv_cycle_vv(new VR(new Immediate(vd.i.access().load().add(Data.valueOf(Type.CARD(5), 0x3)))), new VR(new Immediate(vs2.i.access().load().add(Data.valueOf(Type.CARD(5), 0x3)))), new VR(new Immediate(vs1.i.access().load().add(Data.valueOf(Type.CARD(5), 0x3))))).execute(pe__, vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}