/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class vlw extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "vlw",
          vlw.class,
          null
          );
      addArgument("vd", VR.INFO);
      addArgument("rs1", X.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final VR vd = (VR) getArgument("vd", args);
      final X rs1 = (X) getArgument("rs1", args);

      return new vlw(vd, rs1);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "vlw",
          instruction.class,
          null
          );
      addArgument("vd", VR.INFO);
      addArgument("rs1", X.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final VR vd = (VR) getArgument("vd", args);
      final X rs1 = (X) getArgument("rs1", args);

      return new instruction(
        new vlw(
          vd,
          rs1
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final VR vd;
  public final X rs1;

  public vlw(final VR vd, final X rs1) {
    this.vd = vd;
    this.rs1 = rs1;

    addArgument("vd", vd);
    addArgument("rs1", rs1);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.v_funct7.access().store(Data.valueOf(Type.CARD(7), 0x7));
    vars__.v_funct3.access().store(Data.valueOf(Type.CARD(3), 0x6));
    vars__.v_vm.access().store(Data.valueOf(BIT, 0x1));
    vars__.v_lumop.access().store(Data.valueOf(Type.CARD(5), 0x0));
    vars__.v_mop.access().store(Data.valueOf(Type.CARD(3), 0x4));
    vars__.v_nf.access().store(Data.valueOf(Type.CARD(3), 0x0));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("vlw.v %s, (%s)", vd.text(vars__), rs1.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%3s%3s%1s%5s%5s%3s%5s%7s", vars__.v_nf.access().load().toString(), vars__.v_mop.access().load().toString(), vars__.v_vm.access().load().toString(), vars__.v_lumop.access().load().toString(), rs1.image(vars__), vars__.v_funct3.access().load().toString(), vd.image(vars__), vars__.v_funct7.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    vars__.tmp_address.access().store(rs1.access(pe__, vars__).load());
    new vlw_stride(vd, new Immediate(vars__.tmp_address.access()), new Immediate(Data.valueOf(Type.CARD(4), 0x4)), new Immediate(Data.valueOf(BIT, 0x1))).execute(pe__, vars__);
    new vlw_stride(new VR(new Immediate(vd.i.access().load().add(Data.valueOf(Type.CARD(5), 0x1)))), new Immediate(vars__.tmp_address.access().load().add(Data.valueOf(XWORD, 0x4))), new Immediate(Data.valueOf(Type.CARD(4), 0x4)), new Immediate(Data.valueOf(BIT, 0x1))).execute(pe__, vars__);
    new vlw_stride(new VR(new Immediate(vd.i.access().load().add(Data.valueOf(Type.CARD(5), 0x2)))), new Immediate(vars__.tmp_address.access().load().add(Data.valueOf(XWORD, 0x8))), new Immediate(Data.valueOf(Type.CARD(4), 0x4)), new Immediate(Data.valueOf(BIT, 0x1))).execute(pe__, vars__);
    new vlw_stride(new VR(new Immediate(vd.i.access().load().add(Data.valueOf(Type.CARD(5), 0x3)))), new Immediate(vars__.tmp_address.access().load().add(Data.valueOf(XWORD, 0xc))), new Immediate(Data.valueOf(Type.CARD(4), 0x4)), new Immediate(Data.valueOf(BIT, 0x1))).execute(pe__, vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}