/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class vlw_stride extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "vlw_stride",
          vlw_stride.class,
          null
          );
      addArgument("vd", VR.INFO);
      addArgument("tmp_address_op", XWORD);
      addArgument("load_type", Type.CARD(4));
      addArgument("sign_type", BIT);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final VR vd = (VR) getArgument("vd", args);
      final Immediate tmp_address_op = (Immediate) getArgument("tmp_address_op", args);
      final Immediate load_type = (Immediate) getArgument("load_type", args);
      final Immediate sign_type = (Immediate) getArgument("sign_type", args);

      return new vlw_stride(vd, tmp_address_op, load_type, sign_type);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final VR vd;
  public final Immediate tmp_address_op;
  public final Immediate load_type;
  public final Immediate sign_type;

  public vlw_stride(final VR vd, final Immediate tmp_address_op, final Immediate load_type, final Immediate sign_type) {
    this.vd = vd;
    this.tmp_address_op = tmp_address_op;
    this.load_type = load_type;
    this.sign_type = sign_type;

    addArgument("vd", vd);
    addArgument("tmp_address_op", tmp_address_op);
    addArgument("load_type", load_type);
    addArgument("sign_type", sign_type);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    new load_global(tmp_address_op, new Immediate(Data.valueOf(Type.CARD(4), 0x4)), new Immediate(Data.valueOf(BIT, 0x1))).execute(pe__, vars__);
    vd.access(pe__, vars__).store(vars__.rd_var.access().bitField(31, 0).load());
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}