/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class vsetvli extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "vsetvli",
          vsetvli.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("rs1", X.INFO);
      addArgument("elements", Type.CARD(3));
      addArgument("vlmul", Type.CARD(2));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final X rs1 = (X) getArgument("rs1", args);
      final Immediate elements = (Immediate) getArgument("elements", args);
      final Immediate vlmul = (Immediate) getArgument("vlmul", args);

      return new vsetvli(rd, rs1, elements, vlmul);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "vsetvli",
          instruction.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("rs1", X.INFO);
      addArgument("elements", Type.CARD(3));
      addArgument("vlmul", Type.CARD(2));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final X rs1 = (X) getArgument("rs1", args);
      final Immediate elements = (Immediate) getArgument("elements", args);
      final Immediate vlmul = (Immediate) getArgument("vlmul", args);

      return new instruction(
        new vsetvli(
          rd,
          rs1,
          elements,
          vlmul
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rd;
  public final X rs1;
  public final Immediate elements;
  public final Immediate vlmul;

  public vsetvli(final X rd, final X rs1, final Immediate elements, final Immediate vlmul) {
    this.rd = rd;
    this.rs1 = rs1;
    this.elements = elements;
    this.vlmul = vlmul;

    addArgument("rd", rd);
    addArgument("rs1", rs1);
    addArgument("elements", elements);
    addArgument("vlmul", vlmul);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.v_funct6.access().store(Data.valueOf(Type.CARD(6), 0x17));
    vars__.v_funct5.access().store(Data.valueOf(Type.CARD(5), 0x0));
    vars__.v_funct3.access().store(Data.valueOf(Type.CARD(3), 0x7));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("vsetvli %s, %s, %s, %s", rd.text(vars__), rs1.text(vars__), "e32", "m4");
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("0%5s%3s%2s%5s%3s%5s%7s", vars__.v_funct5.access().load().toString(), elements.access().load().toString(), vlmul.access().load().toString(), rs1.image(vars__), vars__.v_funct3.access().load().toString(), rd.image(vars__), Data.valueOf(Type.CARD(7), 0x57).toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    pe__.VTYPE_VSEW.access().store(elements.access().load());
    pe__.VTYPE_VLMUL.access().store(vlmul.access().load());
    rd.access(pe__, vars__).store(pe__.VTYPE_CSR.access().load());
    pe__.VL_CSR.access().store(Data.valueOf(CSR_TYPE, 0x20));
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}