/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class vsw_stride extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "vsw_stride",
          vsw_stride.class,
          null
          );
      addArgument("vs3", VR.INFO);
      addArgument("tmp_address_op", XWORD);
      addArgument("load_type", Type.CARD(4));}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final VR vs3 = (VR) getArgument("vs3", args);
      final Immediate tmp_address_op = (Immediate) getArgument("tmp_address_op", args);
      final Immediate load_type = (Immediate) getArgument("load_type", args);

      return new vsw_stride(vs3, tmp_address_op, load_type);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final VR vs3;
  public final Immediate tmp_address_op;
  public final Immediate load_type;

  public vsw_stride(final VR vs3, final Immediate tmp_address_op, final Immediate load_type) {
    this.vs3 = vs3;
    this.tmp_address_op = tmp_address_op;
    this.load_type = load_type;

    addArgument("vs3", vs3);
    addArgument("tmp_address_op", tmp_address_op);
    addArgument("load_type", load_type);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.rs2_var.access().bitField(31, 0).store(vs3.access(pe__, vars__).load());
    new store_global(tmp_address_op, new Immediate(vars__.rs2_var.access()), load_type).execute(pe__, vars__);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}