/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86nasm.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.x86nasm.PE;
import ru.ispras.microtesk.model.x86nasm.TempVars;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.x86nasm.TypeDefs.*;

public final class dec_proc_byte extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "dec_proc_byte",
          dec_proc_byte.class,
          null
          );
      addArgument("op1", BYTE);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate op1 = (Immediate) getArgument("op1", args);

      return new dec_proc_byte(op1);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate op1;

  public dec_proc_byte(final Immediate op1) {
    this.op1 = op1;

    addArgument("op1", op1);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.tmpb_res.access().store(Data.zeroExtend(Type.CARD(9), op1.access().load().subtract(Data.valueOf(BYTE, 0x1))));
    pe__.OF.access().store(Data.valueOf(BIT, op1.access().bitField(7, 7).load().equals(Data.valueOf(Type.CARD(1), 0x0)) && vars__.tmpb_res.access().bitField(7, 7).load().equals(Data.valueOf(Type.CARD(1), 0x1))));
    pe__.ZF.access().store(Data.valueOf(BIT, vars__.tmpb_res.access().bitField(7, 0).load().equals(Data.valueOf(Type.CARD(8), 0x0))));
    pe__.SF.access().store(Data.valueOf(BIT, vars__.tmpb_res.access().bitField(7, 7).load().equals(Data.valueOf(Type.CARD(1), 0x1))));
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}